/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 24 "pango.override"
#define NO_IMPORT_PYGOBJECT
#define PANGO_ENABLE_BACKEND
#define PANGO_ENABLE_ENGINE
#include <pygobject.h>
#include <pango/pango.h>

typedef struct {
    PyObject *func, *data;
} PyGtkCustomNotify;

/* ------------- PangoAttribute ------------- */

typedef struct {
    PyObject_HEAD
    PangoAttribute *attr;
} PyPangoAttribute;
staticforward PyTypeObject PyPangoAttribute_Type;

static PyObject *
pypango_attr_new(PangoAttribute *attr, guint start, guint end)
{
    PyPangoAttribute *self;

    self = (PyPangoAttribute *)PyObject_NEW(PyPangoAttribute,
					    &PyPangoAttribute_Type);
    if (self == NULL)
	return NULL;
    self->attr = attr;
    attr->start_index = start;
    attr->end_index = end;

    return (PyObject *)self;
}

static void
pypango_attr_dealloc(PyPangoAttribute *self)
{
    pango_attribute_destroy(self->attr);
    PyObject_DEL(self);
}

static int
pypango_attr_compare(PyPangoAttribute *self, PyPangoAttribute *v)
{
    if (pango_attribute_equal(self->attr, v->attr))
	return 0;
    if (self->attr > v->attr)
	return -1;
    return 1;
}

static long
pypango_attr_hash(PyPangoAttribute *self)
{
    return (long)self->attr;
}

static PyObject *
pypango_attr_copy(PyPangoAttribute *self)
{
    return pypango_attr_new(pango_attribute_copy(self->attr),
			    self->attr->start_index, self->attr->end_index);
}

static PyMethodDef pypango_attr_methods[] = {
    { "copy", (PyCFunction)pypango_attr_copy, METH_NOARGS },
    { NULL, NULL, 0 }
};

static PyObject *
pypango_attr_get_index(PyPangoAttribute *self, void *closure)
{
    gboolean is_end = GPOINTER_TO_INT(closure) != 0;

    if (is_end)
	return PyInt_FromLong(self->attr->end_index);
    else
	return PyInt_FromLong(self->attr->start_index);
}

static int
pypango_attr_set_index(PyPangoAttribute *self, PyObject *value, void *closure)
{
    gboolean is_end = GPOINTER_TO_INT(closure) != 0;
    gint val;

    val = PyInt_AsLong(value);
    if (PyErr_Occurred()) {
	PyErr_Clear();
	PyErr_SetString(PyExc_TypeError, "index must be an integer");
	return -1;
    }
    if (is_end)
	self->attr->end_index = val;
    else
	self->attr->start_index = val;
    return 0;
}

static PyObject *
pypango_attr_get_type(PyPangoAttribute *self, void *closure)
{
    return PyInt_FromLong(self->attr->klass->type);
}

static PyGetSetDef pypango_attr_getsets[] = {
    { "start_index", (getter)pypango_attr_get_index,
      (setter)pypango_attr_set_index, NULL, GINT_TO_POINTER(0) },
    { "end_index", (getter)pypango_attr_get_index,
      (setter)pypango_attr_set_index, NULL, GINT_TO_POINTER(1) },
    { "type", (getter)pypango_attr_get_type, (setter)0, NULL, NULL },
    { NULL, (getter)0, (setter)0, NULL, NULL }
};

static PyObject *
pypango_attr_tp_getattr(PyPangoAttribute *self, char *attr)
{
    PangoAttribute *attribute = self->attr;
    PyObject *name, *ret;

    switch (attribute->klass->type) {
    case PANGO_ATTR_LANGUAGE:
	if (!strcmp(attr, "__members__"))
	    return Py_BuildValue("[s]", "value");
	if (!strcmp(attr, "value"))
	    return pyg_boxed_new(PANGO_TYPE_LANGUAGE,
				 ((PangoAttrLanguage *)attribute)->value,
				 TRUE, TRUE);
	break;
    case PANGO_ATTR_FAMILY:
	if (!strcmp(attr, "__members__"))
	    return Py_BuildValue("[s]", "value");
	if (!strcmp(attr, "value"))
	    return PyString_FromString(((PangoAttrString *)attribute)->value);
	break;
    case PANGO_ATTR_STYLE:
    case PANGO_ATTR_WEIGHT:
    case PANGO_ATTR_VARIANT:
    case PANGO_ATTR_STRETCH:
    case PANGO_ATTR_SIZE:
    case PANGO_ATTR_UNDERLINE:
    case PANGO_ATTR_STRIKETHROUGH:
    case PANGO_ATTR_RISE:
    case PANGO_ATTR_FALLBACK:
	if (!strcmp(attr, "__members__"))
	    return Py_BuildValue("[s]", "value");
	if (!strcmp(attr, "value"))
	    return PyInt_FromLong(((PangoAttrInt *)attribute)->value);
	break;
    case PANGO_ATTR_FONT_DESC:
	if (!strcmp(attr, "__members__"))
	    return Py_BuildValue("[s]", "desc");
	if (!strcmp(attr, "desc"))
	    return pyg_boxed_new(PANGO_TYPE_FONT_DESCRIPTION,
				 ((PangoAttrFontDesc *)attribute)->desc,
				 TRUE, TRUE);
	break;
    case PANGO_ATTR_FOREGROUND:
    case PANGO_ATTR_BACKGROUND:
	if (!strcmp(attr, "__members__"))
	    return Py_BuildValue("[s]", "color");
	if (!strcmp(attr, "color"))
	    return pyg_boxed_new(PANGO_TYPE_COLOR,
				 &((PangoAttrColor *)attribute)->color,
				 TRUE, TRUE);
	break;
    case PANGO_ATTR_SHAPE:
	if (!strcmp(attr, "__members__"))
	    return Py_BuildValue("[ss]", "ink_rect", "logical_rect");
	if (!strcmp(attr, "ink_rect")) {
	    PangoRectangle rect = ((PangoAttrShape *)attribute)->ink_rect;

	    return Py_BuildValue("iiii", rect.x, rect.y,
				 rect.width, rect.height);
	}
	if (!strcmp(attr, "logical_rect")) {
	    PangoRectangle rect = ((PangoAttrShape *)attribute)->logical_rect;

	    return Py_BuildValue("iiii", rect.x, rect.y,
				 rect.width, rect.height);
	}
	break;
    case PANGO_ATTR_SCALE:
	if (!strcmp(attr, "__members__"))
	    return Py_BuildValue("[s]", "value");
	if (!strcmp(attr, "value"))
	    return PyFloat_FromDouble(((PangoAttrFloat *)attribute)->value);
	break;
    default:
	break;
    }

    name = PyString_FromString(attr);
    ret = PyObject_GenericGetAttr((PyObject *)self, name);
    Py_DECREF(name);
    return ret;
}

static PyTypeObject PyPangoAttribute_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.Attribute",			/* tp_name */
    sizeof(PyPangoAttribute),		/* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)pypango_attr_dealloc,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)pypango_attr_tp_getattr,	/* tp_getattr */
    (setattrfunc)0,			/* tp_setattr */
    (cmpfunc)pypango_attr_compare,	/* tp_compare */
    (reprfunc)0,			/* tp_repr */
    0,					/* tp_as_number */
    0,					/* tp_as_sequence */
    0,					/* tp_as_mapping */
    (hashfunc)pypango_attr_hash,	/* tp_hash */
    (ternaryfunc)0,			/* tp_call */
    (reprfunc)0,			/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT,			/* tp_flags */
    NULL, /* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,				/* tp_clear */
    (richcmpfunc)0,			/* tp_richcompare */
    0,					/* tp_weaklistoffset */
    (getiterfunc)0,			/* tp_iter */
    (iternextfunc)0,			/* tp_iternext */
    pypango_attr_methods,		/* tp_methods */
    0,					/* tp_members */
    pypango_attr_getsets,		/* tp_getset */
    (PyTypeObject *)0,			/* tp_base */
    (PyObject *)0,			/* tp_dict */
    0,					/* tp_descr_get */
    0,					/* tp_descr_set */
    0,					/* tp_dictoffset */
    (initproc)0,			/* tp_init */
    (allocfunc)0,			/* tp_alloc */
    (newfunc)0,				/* tp_new */
    0,					/* tp_free */
    (inquiry)0,				/* tp_is_gc */
    (PyObject *)0,			/* tp_bases */
};

/* ------------- PangoAttrIterator ------------- */

typedef struct {
    PyObject_HEAD
    PangoAttrIterator *iter;
} PyPangoAttrIterator;
staticforward PyTypeObject PyPangoAttrIterator_Type;

static PyObject *
pypango_attr_iterator_new(PangoAttrIterator *iter)
{
    PyPangoAttrIterator *self;

    self = (PyPangoAttrIterator *)PyObject_NEW(PyPangoAttrIterator,
					   &PyPangoAttrIterator_Type);
    if (self == NULL)
	return NULL;
    self->iter = iter;

    return (PyObject *)self;
}

static void
pypango_attr_iterator_dealloc(PyPangoAttrIterator *self)
{
    pango_attr_iterator_destroy(self->iter);
    PyObject_DEL(self);
}

static int
pypango_attr_iterator_compare(PyPangoAttrIterator *self,
			      PyPangoAttrIterator *v)
{
    if (self->iter == v->iter)
	return 0;
    if (self->iter > v->iter)
	return -1;
    return 1;
}

static long
pypango_attr_iterator_hash(PyPangoAttrIterator *self)
{
    return (long)self->iter;
}

static PyObject *
pypango_attr_iterator_copy(PyPangoAttrIterator *self)
{
    return pypango_attr_iterator_new(pango_attr_iterator_copy(self->iter));
}

static PyObject *
pypango_attr_iterator_range(PyPangoAttrIterator *self)
{
    gint start, end;

    pango_attr_iterator_range(self->iter, &start, &end);
    return Py_BuildValue("ii", start, end);
}

static PyObject *
pypango_attr_iterator_next(PyPangoAttrIterator *self)
{
    return PyBool_FromLong(pango_attr_iterator_next(self->iter));
}

static PyObject *
pypango_attr_iterator_get(PyPangoAttrIterator *self, PyObject *args,
			  PyObject *kwargs)
{
    static char *kwlist[] = { "type", NULL };
    PyObject *py_type;
    PangoAttrType type;
    PangoAttribute *attr;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:pango.AttrIterator.get",
				     kwlist, &py_type))
	return NULL;

    if (pyg_enum_get_value(PANGO_TYPE_ATTR_TYPE, py_type, (gint*)&type))
	return NULL;

    if (!(attr = pango_attr_iterator_get(self->iter, type))) {
	Py_INCREF(Py_None);
	return Py_None;
    }

    return pypango_attr_new(attr, attr->start_index, attr->end_index);
}

static PyObject *
pypango_attr_iterator_get_font(PyPangoAttrIterator *self)
{
    PangoFontDescription *desc;
    PangoLanguage *language;
    GSList *extra_attrs, *tmp;
    PyObject *py_desc, *py_language, *py_extra_attrs;

    if (!(desc = pango_font_description_new())) {
	PyErr_SetString(PyExc_RuntimeError, "can't get font info");
	return NULL;
    }
    pango_attr_iterator_get_font(self->iter, desc, &language, &extra_attrs);
    py_desc = pyg_boxed_new(PANGO_TYPE_FONT_DESCRIPTION, desc, TRUE, TRUE);
    py_language = pyg_boxed_new(PANGO_TYPE_LANGUAGE, language, TRUE, TRUE);

    py_extra_attrs = PyList_New(0);
    for (tmp = extra_attrs; tmp != NULL; tmp = tmp->next) {
	PangoAttribute *attr = (PangoAttribute *)tmp->data;
	PyObject *py_attr = pypango_attr_new(attr, attr->start_index,
					  attr->end_index);
	PyList_Append(py_extra_attrs, py_attr);
	Py_DECREF(py_attr);
    }
    g_slist_free(extra_attrs);

    return Py_BuildValue("NNN", py_desc, py_language, py_extra_attrs);
}

static PyObject *
pypango_attr_iterator_get_attrs(PyPangoAttrIterator *self)
{
    GSList *alist;
    PyObject *py_list;
    guint i, len;

    alist = pango_attr_iterator_get_attrs(self->iter);

    len = g_slist_length(alist);
    py_list = PyTuple_New(len);
    for (i = 0; i < len; i++) {
	PangoAttribute *attr = (PangoAttribute *)g_slist_nth_data(alist, i);
	
	PyTuple_SetItem(py_list, i, pypango_attr_new(attr, attr->start_index,
						     attr->end_index));
    }
    /* don't have to destroy attributes since we use them */
    g_slist_free(alist);
    return py_list;
}

static PyMethodDef pypango_attr_iterator_methods[] = {
    { "copy", (PyCFunction)pypango_attr_iterator_copy, METH_NOARGS },
    { "range", (PyCFunction)pypango_attr_iterator_range, METH_NOARGS },
    { "next", (PyCFunction)pypango_attr_iterator_next, METH_NOARGS },
    { "get", (PyCFunction)pypango_attr_iterator_get, METH_VARARGS|METH_KEYWORDS },
    { "get_font", (PyCFunction)pypango_attr_iterator_get_font, METH_NOARGS },
    { "get_attrs", (PyCFunction)pypango_attr_iterator_get_attrs, METH_NOARGS },
    { NULL, NULL, 0 }
};

static PyTypeObject PyPangoAttrIterator_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.AttrIterator",			/* tp_name */
    sizeof(PyPangoAttrIterator),		/* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)pypango_attr_iterator_dealloc,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,			/* tp_getattr */
    (setattrfunc)0,			/* tp_setattr */
    (cmpfunc)pypango_attr_iterator_compare,	/* tp_compare */
    (reprfunc)0,			/* tp_repr */
    0,					/* tp_as_number */
    0,					/* tp_as_sequence */
    0,					/* tp_as_mapping */
    (hashfunc)pypango_attr_iterator_hash,	/* tp_hash */
    (ternaryfunc)0,			/* tp_call */
    (reprfunc)0,			/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT,			/* tp_flags */
    NULL, /* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,				/* tp_clear */
    (richcmpfunc)0,			/* tp_richcompare */
    0,					/* tp_weaklistoffset */
    (getiterfunc)0,			/* tp_iter */
    (iternextfunc)0,			/* tp_iternext */
    pypango_attr_iterator_methods,	/* tp_methods */
    0,					/* tp_members */
    0,					/* tp_getset */
    (PyTypeObject *)0,			/* tp_base */
    (PyObject *)0,			/* tp_dict */
    0,					/* tp_descr_get */
    0,					/* tp_descr_set */
    0,					/* tp_dictoffset */
    (initproc)0,			/* tp_init */
    (allocfunc)0,			/* tp_alloc */
    (newfunc)0,				/* tp_new */
    0,					/* tp_free */
    (inquiry)0,				/* tp_is_gc */
    (PyObject *)0,			/* tp_bases */
};

#line 451 "pango.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyPangoAttrList_Type;
PyTypeObject PyPangoColor_Type;
PyTypeObject PyPangoFontDescription_Type;
PyTypeObject PyPangoFontMetrics_Type;
PyTypeObject PyPangoGlyphString_Type;
PyTypeObject PyPangoLanguage_Type;
PyTypeObject PyPangoTabArray_Type;
PyTypeObject PyPangoContext_Type;
PyTypeObject PyPangoFont_Type;
PyTypeObject PyPangoFontFace_Type;
PyTypeObject PyPangoFontFamily_Type;
PyTypeObject PyPangoFontMap_Type;
PyTypeObject PyPangoFontset_Type;
PyTypeObject PyPangoFontsetSimple_Type;
PyTypeObject PyPangoLayout_Type;


/* ----------- PangoAttrList ----------- */

static int
_wrap_pango_attr_list_new(PyGBoxed *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":PangoAttrList.__init__", kwlist))
        return -1;
    self->gtype = PANGO_TYPE_ATTR_LIST;
    self->free_on_dealloc = FALSE;
    self->boxed = pango_attr_list_new();

    if (!self->boxed) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PangoAttrList object");
        return -1;
    }
    self->free_on_dealloc = TRUE;
    return 0;
}

static PyObject *
_wrap_pango_attr_list_copy(PyObject *self)
{
    PangoAttrList *ret;

    ret = pango_attr_list_copy(pyg_boxed_get(self, PangoAttrList));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_ATTR_LIST, ret, TRUE, TRUE);
}

#line 801 "pango.override"
static PyObject *
_wrap_pango_attr_list_insert(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "attr", NULL };
    PyPangoAttribute *py_attr;
    PangoAttribute *attr;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "O!:PangoAttrList.insert", kwlist,
				     &PyPangoAttribute_Type, &py_attr))
	return NULL;
    attr = pango_attribute_copy(py_attr->attr);

    pango_attr_list_insert(pyg_boxed_get(self, PangoAttrList), attr);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 527 "pango.c"


#line 821 "pango.override"
static PyObject *
_wrap_pango_attr_list_insert_before(PyObject *self, PyObject *args,
				    PyObject *kwargs)
{
    static char *kwlist[] = { "attr", NULL };
    PyPangoAttribute *py_attr;
    PangoAttribute *attr;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "O!:PangoAttrList.insert_before", kwlist,
				     &PyPangoAttribute_Type, &py_attr))
	return NULL;
    attr = pango_attribute_copy(py_attr->attr);

    pango_attr_list_insert_before(pyg_boxed_get(self, PangoAttrList), attr);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 550 "pango.c"


#line 842 "pango.override"
static PyObject *
_wrap_pango_attr_list_change(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "attr", NULL };
    PyPangoAttribute *py_attr;
    PangoAttribute *attr;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "O!:PangoAttrList.change", kwlist,
				     &PyPangoAttribute_Type, &py_attr))
	return NULL;
    attr = pango_attribute_copy(py_attr->attr);

    pango_attr_list_change(pyg_boxed_get(self, PangoAttrList), attr);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 572 "pango.c"


static PyObject *
_wrap_pango_attr_list_splice(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "other", "pos", "len", NULL };
    PyObject *py_other;
    int pos, len;
    PangoAttrList *other = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "Oii:PangoAttrList.splice", kwlist, &py_other, &pos, &len))
        return NULL;
    if (pyg_boxed_check(py_other, PANGO_TYPE_ATTR_LIST))
        other = pyg_boxed_get(py_other, PangoAttrList);
    else {
        PyErr_SetString(PyExc_TypeError, "other should be a PangoAttrList");
        return NULL;
    }
    pango_attr_list_splice(pyg_boxed_get(self, PangoAttrList), other, pos, len);
    Py_INCREF(Py_None);
    return Py_None;
}

#line 1407 "pango.override"
static PyObject *
_wrap_pango_attr_list_get_iterator(PyGBoxed *self)
{
    PangoAttrList *list = pyg_boxed_get(self, PangoAttrList);
    PangoAttrIterator *iter = pango_attr_list_get_iterator(list);

    return pypango_attr_iterator_new(iter);
}
#line 605 "pango.c"


#line 1517 "pango.override"
static gboolean
pypango_attr_list_filter_cb(PangoAttribute *attr, gpointer data)
{
    PyGILState_STATE state;
    PyGtkCustomNotify *cunote = data;
    PyObject *retobj, *py_attr;
    gboolean ret = FALSE;
    
    state = pyg_gil_state_ensure();

    py_attr = pypango_attr_new(pango_attribute_copy(attr),
			       attr->start_index, attr->end_index);

    if (cunote->data)
	retobj = PyObject_CallFunction(cunote->func, "NO", py_attr,
				       cunote->data);
    else
	retobj = PyObject_CallFunction(cunote->func, "N", py_attr);

    if (retobj != NULL) {
	ret = PyObject_IsTrue(retobj);
        Py_DECREF(retobj);
    } else {
        PyErr_Print();
    }

    pyg_gil_state_release(state);
    return ret;
}
static PyObject *
_wrap_pango_attr_list_filter(PyGBoxed *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "func", "data", NULL };
    PyObject *py_func, *py_data = NULL;
    PangoAttrList *attr_list, *filtered_list;
    PyGtkCustomNotify cunote;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "O|O:pango.AttrList.filter",
				     kwlist, &py_func, &py_data))
	return NULL;

    if (!PyCallable_Check(py_func)) {
        PyErr_SetString(PyExc_TypeError, "func must be callable");
        return NULL;
    }

    cunote.func = py_func;
    cunote.data = py_data;
    Py_INCREF(cunote.func);
    Py_XINCREF(cunote.data);

    attr_list = (PangoAttrList *)pyg_boxed_get(self, PangoAttrList);
    filtered_list = pango_attr_list_filter(attr_list,
					   pypango_attr_list_filter_cb,
					   (gpointer)&cunote);

    Py_DECREF(cunote.func);
    Py_XDECREF(cunote.data);

    if (filtered_list)
	return pyg_boxed_new(PANGO_TYPE_ATTR_LIST, filtered_list, FALSE, TRUE);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 675 "pango.c"


static PyMethodDef _PyPangoAttrList_methods[] = {
    { "copy", (PyCFunction)_wrap_pango_attr_list_copy, METH_NOARGS },
    { "insert", (PyCFunction)_wrap_pango_attr_list_insert, METH_VARARGS|METH_KEYWORDS },
    { "insert_before", (PyCFunction)_wrap_pango_attr_list_insert_before, METH_VARARGS|METH_KEYWORDS },
    { "change", (PyCFunction)_wrap_pango_attr_list_change, METH_VARARGS|METH_KEYWORDS },
    { "splice", (PyCFunction)_wrap_pango_attr_list_splice, METH_VARARGS|METH_KEYWORDS },
    { "get_iterator", (PyCFunction)_wrap_pango_attr_list_get_iterator, METH_NOARGS },
    { "filter", (PyCFunction)_wrap_pango_attr_list_filter, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoAttrList_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.AttrList",			/* tp_name */
    sizeof(PyGBoxed),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoAttrList_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_pango_attr_list_new,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoColor ----------- */

#line 1380 "pango.override"
static int
_wrap_pango_color_parse(PyGBoxed *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "spec", NULL };
    char *spec;
    PangoColor color;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:PangoColor.__init__",
				     kwlist, &spec))
        return -1;

    self->gtype = PANGO_TYPE_COLOR;
    self->free_on_dealloc = FALSE;

    if (pango_color_parse(&color, spec) != TRUE
	|| !(self->boxed = pango_color_copy(&color))) {
        PyErr_SetString(PyExc_RuntimeError,
			"could not create PangoColor object");
        return -1;
    }

    self->free_on_dealloc = TRUE;

    return 0;
}
#line 764 "pango.c"


static PyObject *
_wrap_pango_color__get_red(PyObject *self, void *closure)
{
    int ret;

    ret = pyg_boxed_get(self, PangoColor)->red;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_color__get_green(PyObject *self, void *closure)
{
    int ret;

    ret = pyg_boxed_get(self, PangoColor)->green;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_color__get_blue(PyObject *self, void *closure)
{
    int ret;

    ret = pyg_boxed_get(self, PangoColor)->blue;
    return PyInt_FromLong(ret);
}

static PyGetSetDef pango_color_getsets[] = {
    { "red", (getter)_wrap_pango_color__get_red, (setter)0 },
    { "green", (getter)_wrap_pango_color__get_green, (setter)0 },
    { "blue", (getter)_wrap_pango_color__get_blue, (setter)0 },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject PyPangoColor_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.Color",			/* tp_name */
    sizeof(PyGBoxed),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    pango_color_getsets,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_pango_color_parse,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFontDescription ----------- */

#line 864 "pango.override"
static int
_wrap_pango_font_description_new(PyGBoxed *self, PyObject *args,
				 PyObject *kwargs)
{
    static char *kwlist[] = { "str", NULL };
    char *str = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "|z:PangoFontDescription.__init__",
				     kwlist, &str))
	return -1;

    self->gtype = PANGO_TYPE_FONT_DESCRIPTION;
    self->free_on_dealloc = FALSE;
    if (str)
	self->boxed = pango_font_description_from_string(str);
    else
	self->boxed = pango_font_description_new();
    if (!self->boxed) {
	PyErr_SetString(PyExc_RuntimeError,
			"could not create PangoFontDescription object");
	return -1;
    }
    self->free_on_dealloc = TRUE;
    return 0;
}
#line 877 "pango.c"


#line 913 "pango.override"
static PyObject *
_wrap_pango_font_description_copy(PyObject *self)
{
    return pyg_boxed_new(PANGO_TYPE_FONT_DESCRIPTION,
			 pyg_boxed_get(self, PangoFontDescription),
			 TRUE, TRUE);
}
#line 888 "pango.c"


static PyObject *
_wrap_pango_font_description_copy_static(PyObject *self)
{
    PangoFontDescription *ret;

    ret = pango_font_description_copy_static(pyg_boxed_get(self, PangoFontDescription));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_FONT_DESCRIPTION, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pango_font_description_hash(PyObject *self)
{
    int ret;

    ret = pango_font_description_hash(pyg_boxed_get(self, PangoFontDescription));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_font_description_set_family(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "family", NULL };
    char *family;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:PangoFontDescription.set_family", kwlist, &family))
        return NULL;
    pango_font_description_set_family(pyg_boxed_get(self, PangoFontDescription), family);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_set_family_static(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "family", NULL };
    char *family;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:PangoFontDescription.set_family_static", kwlist, &family))
        return NULL;
    pango_font_description_set_family_static(pyg_boxed_get(self, PangoFontDescription), family);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_get_family(PyObject *self)
{
    const gchar *ret;

    ret = pango_font_description_get_family(pyg_boxed_get(self, PangoFontDescription));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_set_style(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "style", NULL };
    PangoStyle style;
    PyObject *py_style = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoFontDescription.set_style", kwlist, &py_style))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_STYLE, py_style, (gint *)&style))
        return NULL;
    pango_font_description_set_style(pyg_boxed_get(self, PangoFontDescription), style);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_get_style(PyObject *self)
{
    gint ret;

    ret = pango_font_description_get_style(pyg_boxed_get(self, PangoFontDescription));
    return pyg_enum_from_gtype(PANGO_TYPE_STYLE, ret);
}

static PyObject *
_wrap_pango_font_description_set_variant(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "variant", NULL };
    PyObject *py_variant = NULL;
    PangoVariant variant;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoFontDescription.set_variant", kwlist, &py_variant))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_VARIANT, py_variant, (gint *)&variant))
        return NULL;
    pango_font_description_set_variant(pyg_boxed_get(self, PangoFontDescription), variant);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_get_variant(PyObject *self)
{
    gint ret;

    ret = pango_font_description_get_variant(pyg_boxed_get(self, PangoFontDescription));
    return pyg_enum_from_gtype(PANGO_TYPE_VARIANT, ret);
}

static PyObject *
_wrap_pango_font_description_set_weight(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "weight", NULL };
    PangoWeight weight;
    PyObject *py_weight = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoFontDescription.set_weight", kwlist, &py_weight))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_WEIGHT, py_weight, (gint *)&weight))
        return NULL;
    pango_font_description_set_weight(pyg_boxed_get(self, PangoFontDescription), weight);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_get_weight(PyObject *self)
{
    gint ret;

    ret = pango_font_description_get_weight(pyg_boxed_get(self, PangoFontDescription));
    return pyg_enum_from_gtype(PANGO_TYPE_WEIGHT, ret);
}

static PyObject *
_wrap_pango_font_description_set_stretch(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "stretch", NULL };
    PyObject *py_stretch = NULL;
    PangoStretch stretch;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoFontDescription.set_stretch", kwlist, &py_stretch))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_STRETCH, py_stretch, (gint *)&stretch))
        return NULL;
    pango_font_description_set_stretch(pyg_boxed_get(self, PangoFontDescription), stretch);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_get_stretch(PyObject *self)
{
    gint ret;

    ret = pango_font_description_get_stretch(pyg_boxed_get(self, PangoFontDescription));
    return pyg_enum_from_gtype(PANGO_TYPE_STRETCH, ret);
}

static PyObject *
_wrap_pango_font_description_set_size(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "size", NULL };
    int size;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoFontDescription.set_size", kwlist, &size))
        return NULL;
    pango_font_description_set_size(pyg_boxed_get(self, PangoFontDescription), size);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_get_size(PyObject *self)
{
    int ret;

    ret = pango_font_description_get_size(pyg_boxed_get(self, PangoFontDescription));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_font_description_get_set_fields(PyObject *self)
{
    guint ret;

    ret = pango_font_description_get_set_fields(pyg_boxed_get(self, PangoFontDescription));
    return pyg_flags_from_gtype(PANGO_TYPE_FONT_MASK, ret);
}

static PyObject *
_wrap_pango_font_description_unset_fields(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "to_unset", NULL };
    PyObject *py_to_unset = NULL;
    PangoFontMask to_unset;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoFontDescription.unset_fields", kwlist, &py_to_unset))
        return NULL;
    if (pyg_flags_get_value(PANGO_TYPE_FONT_MASK, py_to_unset, (gint *)&to_unset))
        return NULL;
    pango_font_description_unset_fields(pyg_boxed_get(self, PangoFontDescription), to_unset);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_merge(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "desc_to_merge", "replace_existing", NULL };
    PyObject *py_desc_to_merge;
    int replace_existing;
    PangoFontDescription *desc_to_merge = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "Oi:PangoFontDescription.merge", kwlist, &py_desc_to_merge, &replace_existing))
        return NULL;
    if (pyg_boxed_check(py_desc_to_merge, PANGO_TYPE_FONT_DESCRIPTION))
        desc_to_merge = pyg_boxed_get(py_desc_to_merge, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc_to_merge should be a PangoFontDescription");
        return NULL;
    }
    pango_font_description_merge(pyg_boxed_get(self, PangoFontDescription), desc_to_merge, replace_existing);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_merge_static(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "desc_to_merge", "replace_existing", NULL };
    PyObject *py_desc_to_merge;
    int replace_existing;
    PangoFontDescription *desc_to_merge = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "Oi:PangoFontDescription.merge_static", kwlist, &py_desc_to_merge, &replace_existing))
        return NULL;
    if (pyg_boxed_check(py_desc_to_merge, PANGO_TYPE_FONT_DESCRIPTION))
        desc_to_merge = pyg_boxed_get(py_desc_to_merge, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc_to_merge should be a PangoFontDescription");
        return NULL;
    }
    pango_font_description_merge_static(pyg_boxed_get(self, PangoFontDescription), desc_to_merge, replace_existing);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_better_match(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "old_match", "new_match", NULL };
    PyObject *py_old_match = Py_None, *py_new_match;
    int ret;
    PangoFontDescription *old_match = NULL, *new_match = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|OO:PangoFontDescription.better_match", kwlist, &py_old_match, &py_new_match))
        return NULL;
    if (pyg_boxed_check(py_old_match, PANGO_TYPE_FONT_DESCRIPTION))
        old_match = pyg_boxed_get(py_old_match, PangoFontDescription);
    else if (py_old_match != Py_None) {
        PyErr_SetString(PyExc_TypeError, "old_match should be a PangoFontDescription or None");
        return NULL;
    }
    if (pyg_boxed_check(py_new_match, PANGO_TYPE_FONT_DESCRIPTION))
        new_match = pyg_boxed_get(py_new_match, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "new_match should be a PangoFontDescription");
        return NULL;
    }
    ret = pango_font_description_better_match(pyg_boxed_get(self, PangoFontDescription), old_match, new_match);
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_pango_font_description_to_string(PyObject *self)
{
    gchar *ret;

    ret = pango_font_description_to_string(pyg_boxed_get(self, PangoFontDescription));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_description_to_filename(PyObject *self)
{
    gchar *ret;

    ret = pango_font_description_to_filename(pyg_boxed_get(self, PangoFontDescription));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyPangoFontDescription_methods[] = {
    { "copy", (PyCFunction)_wrap_pango_font_description_copy, METH_NOARGS },
    { "copy_static", (PyCFunction)_wrap_pango_font_description_copy_static, METH_NOARGS },
    { "hash", (PyCFunction)_wrap_pango_font_description_hash, METH_NOARGS },
    { "set_family", (PyCFunction)_wrap_pango_font_description_set_family, METH_VARARGS|METH_KEYWORDS },
    { "set_family_static", (PyCFunction)_wrap_pango_font_description_set_family_static, METH_VARARGS|METH_KEYWORDS },
    { "get_family", (PyCFunction)_wrap_pango_font_description_get_family, METH_NOARGS },
    { "set_style", (PyCFunction)_wrap_pango_font_description_set_style, METH_VARARGS|METH_KEYWORDS },
    { "get_style", (PyCFunction)_wrap_pango_font_description_get_style, METH_NOARGS },
    { "set_variant", (PyCFunction)_wrap_pango_font_description_set_variant, METH_VARARGS|METH_KEYWORDS },
    { "get_variant", (PyCFunction)_wrap_pango_font_description_get_variant, METH_NOARGS },
    { "set_weight", (PyCFunction)_wrap_pango_font_description_set_weight, METH_VARARGS|METH_KEYWORDS },
    { "get_weight", (PyCFunction)_wrap_pango_font_description_get_weight, METH_NOARGS },
    { "set_stretch", (PyCFunction)_wrap_pango_font_description_set_stretch, METH_VARARGS|METH_KEYWORDS },
    { "get_stretch", (PyCFunction)_wrap_pango_font_description_get_stretch, METH_NOARGS },
    { "set_size", (PyCFunction)_wrap_pango_font_description_set_size, METH_VARARGS|METH_KEYWORDS },
    { "get_size", (PyCFunction)_wrap_pango_font_description_get_size, METH_NOARGS },
    { "get_set_fields", (PyCFunction)_wrap_pango_font_description_get_set_fields, METH_NOARGS },
    { "unset_fields", (PyCFunction)_wrap_pango_font_description_unset_fields, METH_VARARGS|METH_KEYWORDS },
    { "merge", (PyCFunction)_wrap_pango_font_description_merge, METH_VARARGS|METH_KEYWORDS },
    { "merge_static", (PyCFunction)_wrap_pango_font_description_merge_static, METH_VARARGS|METH_KEYWORDS },
    { "better_match", (PyCFunction)_wrap_pango_font_description_better_match, METH_VARARGS|METH_KEYWORDS },
    { "to_string", (PyCFunction)_wrap_pango_font_description_to_string, METH_NOARGS },
    { "to_filename", (PyCFunction)_wrap_pango_font_description_to_filename, METH_NOARGS },
    { NULL, NULL, 0 }
};

#line 892 "pango.override"
static int
_wrap_pango_font_description_tp_compare(PyGBoxed *self, PyGBoxed *other)
{
    if (self->boxed == other->boxed ||
	pango_font_description_equal(pyg_boxed_get(self, PangoFontDescription),
				pyg_boxed_get(other, PangoFontDescription)))
	return 0;
    if (self->boxed > other->boxed)
	return -1;
    return 1;
}
#line 1233 "pango.c"


#line 905 "pango.override"
static long
_wrap_pango_font_description_tp_hash(PyGBoxed *self)
{
    return (long)pango_font_description_hash(
		pyg_boxed_get(self, PangoFontDescription));
}
#line 1243 "pango.c"


PyTypeObject PyPangoFontDescription_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.FontDescription",			/* tp_name */
    sizeof(PyGBoxed),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)_wrap_pango_font_description_tp_compare,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)_wrap_pango_font_description_tp_hash,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFontDescription_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_pango_font_description_new,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFontMetrics ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

static PyObject *
_wrap_pango_font_metrics_get_ascent(PyObject *self)
{
    int ret;

    ret = pango_font_metrics_get_ascent(pyg_boxed_get(self, PangoFontMetrics));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_font_metrics_get_descent(PyObject *self)
{
    int ret;

    ret = pango_font_metrics_get_descent(pyg_boxed_get(self, PangoFontMetrics));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_font_metrics_get_approximate_char_width(PyObject *self)
{
    int ret;

    ret = pango_font_metrics_get_approximate_char_width(pyg_boxed_get(self, PangoFontMetrics));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_font_metrics_get_approximate_digit_width(PyObject *self)
{
    int ret;

    ret = pango_font_metrics_get_approximate_digit_width(pyg_boxed_get(self, PangoFontMetrics));
    return PyInt_FromLong(ret);
}

static PyMethodDef _PyPangoFontMetrics_methods[] = {
    { "get_ascent", (PyCFunction)_wrap_pango_font_metrics_get_ascent, METH_NOARGS },
    { "get_descent", (PyCFunction)_wrap_pango_font_metrics_get_descent, METH_NOARGS },
    { "get_approximate_char_width", (PyCFunction)_wrap_pango_font_metrics_get_approximate_char_width, METH_NOARGS },
    { "get_approximate_digit_width", (PyCFunction)_wrap_pango_font_metrics_get_approximate_digit_width, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoFontMetrics_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.FontMetrics",			/* tp_name */
    sizeof(PyGBoxed),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFontMetrics_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoGlyphString ----------- */

static int
_wrap_pango_glyph_string_new(PyGBoxed *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":PangoGlyphString.__init__", kwlist))
        return -1;
    self->gtype = PANGO_TYPE_GLYPH_STRING;
    self->free_on_dealloc = FALSE;
    self->boxed = pango_glyph_string_new();

    if (!self->boxed) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PangoGlyphString object");
        return -1;
    }
    self->free_on_dealloc = TRUE;
    return 0;
}

static PyObject *
_wrap_pango_glyph_string_set_size(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "new_len", NULL };
    int new_len;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoGlyphString.set_size", kwlist, &new_len))
        return NULL;
    pango_glyph_string_set_size(pyg_boxed_get(self, PangoGlyphString), new_len);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_glyph_string_copy(PyObject *self)
{
    PangoGlyphString *ret;

    ret = pango_glyph_string_copy(pyg_boxed_get(self, PangoGlyphString));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_GLYPH_STRING, ret, TRUE, TRUE);
}

#line 1007 "pango.override"
static PyObject *
_wrap_pango_glyph_string_extents(PyObject *self, PyObject *args,
				 PyObject *kwargs)
{
    static char *kwlist[] = { "font", NULL };
    PyObject *font;
    PangoRectangle ink_rect, logical_rect;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "O:PangoGlyphString.extents", kwlist,
				     &font))
	return NULL;
    if (!pygobject_check(font, &PyPangoFont_Type)) {
	PyErr_SetString(PyExc_TypeError, "font must be a PangoFont");
	return NULL;
    }

    pango_glyph_string_extents(pyg_boxed_get(self, PangoGlyphString),
			       PANGO_FONT(pygobject_get(font)),
			       &ink_rect, &logical_rect);

    return Py_BuildValue("((iiii)(iiii))",
			 ink_rect.x, ink_rect.y,
			 ink_rect.width, ink_rect.height,
			 logical_rect.x, logical_rect.y,
			 logical_rect.width, logical_rect.height);
}
#line 1468 "pango.c"


#line 1036 "pango.override"
static PyObject *
_wrap_pango_glyph_string_extents_range(PyObject *self, PyObject *args,
				       PyObject *kwargs)
{
    static char *kwlist[] = { "start", "end", "font", NULL };
    gint start, end;
    PyObject *font;
    PangoRectangle ink_rect, logical_rect;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "iiO:PangoGlyphString.extents_range",
				     kwlist, &start, &end, &font))
	return NULL;
    if (!pygobject_check(font, &PyPangoFont_Type)) {
	PyErr_SetString(PyExc_TypeError, "font must be a PangoFont");
	return NULL;
    }

    pango_glyph_string_extents_range(pyg_boxed_get(self, PangoGlyphString),
				     start, end,
				     PANGO_FONT(pygobject_get(font)),
				     &ink_rect, &logical_rect);

    return Py_BuildValue("((iiii)(iiii))",
			 ink_rect.x, ink_rect.y,
			 ink_rect.width, ink_rect.height,
			 logical_rect.x, logical_rect.y,
			 logical_rect.width, logical_rect.height);
}
#line 1501 "pango.c"


#line 1067 "pango.override"
static PyObject *
_wrap_pango_glyph_string_get_logical_widths(PyObject *self, PyObject *args,
					    PyObject *kwargs)
{
    static char *kwlist[] = { "text", "embedding_level", NULL };
    const char *text;
    gint length, embedding_level, *logical_widths;
    gint i, slen;
    PyObject *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "s#i:PangoGlyphString.get_logical_widths",
				     kwlist, &text, &length, &embedding_level))
	return NULL;
    slen = g_utf8_strlen(text, length);
    logical_widths = g_new(int, slen);
    pango_glyph_string_get_logical_widths(pyg_boxed_get(self,PangoGlyphString),
					  text, length, embedding_level,
					  logical_widths);
    ret = PyTuple_New(slen);
    for (i = 0; i < slen; i++) {
	PyObject *item = PyInt_FromLong(logical_widths[i]);

	PyTuple_SetItem(ret, i, item);
    }
    g_free(logical_widths);
    return ret;
}
#line 1533 "pango.c"


static PyMethodDef _PyPangoGlyphString_methods[] = {
    { "set_size", (PyCFunction)_wrap_pango_glyph_string_set_size, METH_VARARGS|METH_KEYWORDS },
    { "copy", (PyCFunction)_wrap_pango_glyph_string_copy, METH_NOARGS },
    { "extents", (PyCFunction)_wrap_pango_glyph_string_extents, METH_VARARGS|METH_KEYWORDS },
    { "extents_range", (PyCFunction)_wrap_pango_glyph_string_extents_range, METH_VARARGS|METH_KEYWORDS },
    { "get_logical_widths", (PyCFunction)_wrap_pango_glyph_string_get_logical_widths, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

static PyObject *
_wrap_pango_glyph_string__get_num_glyphs(PyObject *self, void *closure)
{
    int ret;

    ret = pyg_boxed_get(self, PangoGlyphString)->num_glyphs;
    return PyInt_FromLong(ret);
}

static PyGetSetDef pango_glyph_string_getsets[] = {
    { "num_glyphs", (getter)_wrap_pango_glyph_string__get_num_glyphs, (setter)0 },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject PyPangoGlyphString_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.GlyphString",			/* tp_name */
    sizeof(PyGBoxed),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoGlyphString_methods,			/* tp_methods */
    0,					/* tp_members */
    pango_glyph_string_getsets,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_pango_glyph_string_new,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoLanguage ----------- */

static int
_wrap_pango_language_from_string(PyGBoxed *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "language", NULL };
    char *language;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:PangoLanguage.__init__", kwlist, &language))
        return -1;
    self->gtype = PANGO_TYPE_LANGUAGE;
    self->free_on_dealloc = FALSE;
    self->boxed = pango_language_from_string(language);

    if (!self->boxed) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PangoLanguage object");
        return -1;
    }
    self->free_on_dealloc = TRUE;
    return 0;
}

static PyObject *
_wrap_pango_language_matches(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "range_list", NULL };
    char *range_list;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:PangoLanguage.matches", kwlist, &range_list))
        return NULL;
    ret = pango_language_matches(pyg_boxed_get(self, PangoLanguage), range_list);
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_pango_language_to_string(PyObject *self)
{
    const gchar *ret;

    ret = pango_language_to_string(pyg_boxed_get(self, PangoLanguage));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyPangoLanguage_methods[] = {
    { "matches", (PyCFunction)_wrap_pango_language_matches, METH_VARARGS|METH_KEYWORDS },
    { "to_string", (PyCFunction)_wrap_pango_language_to_string, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoLanguage_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.Language",			/* tp_name */
    sizeof(PyGBoxed),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoLanguage_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_pango_language_from_string,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoTabArray ----------- */

static int
_wrap_pango_tab_array_new(PyGBoxed *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "initial_size", "positions_in_pixels", NULL };
    int initial_size, positions_in_pixels;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:PangoTabArray.__init__", kwlist, &initial_size, &positions_in_pixels))
        return -1;
    self->gtype = PANGO_TYPE_TAB_ARRAY;
    self->free_on_dealloc = FALSE;
    self->boxed = pango_tab_array_new(initial_size, positions_in_pixels);

    if (!self->boxed) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PangoTabArray object");
        return -1;
    }
    self->free_on_dealloc = TRUE;
    return 0;
}

static PyObject *
_wrap_pango_tab_array_copy(PyObject *self)
{
    PangoTabArray *ret;

    ret = pango_tab_array_copy(pyg_boxed_get(self, PangoTabArray));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_TAB_ARRAY, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pango_tab_array_get_size(PyObject *self)
{
    int ret;

    ret = pango_tab_array_get_size(pyg_boxed_get(self, PangoTabArray));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_tab_array_resize(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "new_size", NULL };
    int new_size;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoTabArray.resize", kwlist, &new_size))
        return NULL;
    pango_tab_array_resize(pyg_boxed_get(self, PangoTabArray), new_size);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_tab_array_set_tab(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "tab_index", "alignment", "location", NULL };
    int tab_index, location;
    PyObject *py_alignment = NULL;
    PangoTabAlign alignment;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iOi:PangoTabArray.set_tab", kwlist, &tab_index, &py_alignment, &location))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_TAB_ALIGN, py_alignment, (gint *)&alignment))
        return NULL;
    pango_tab_array_set_tab(pyg_boxed_get(self, PangoTabArray), tab_index, alignment, location);
    Py_INCREF(Py_None);
    return Py_None;
}

#line 1326 "pango.override"
static PyObject *
_wrap_pango_tab_array_get_tab(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "tab_index", NULL };
    gint tab_index, location;
    PangoTabAlign alignment;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoTabArray.get_tab",
				     kwlist, &tab_index))
	return NULL;

    pango_tab_array_get_tab(pyg_boxed_get(self, PangoTabArray),
			    tab_index, &alignment, &location);
    return Py_BuildValue("(ii)", (int)alignment, location);
}
#line 1794 "pango.c"


#line 1343 "pango.override"
static PyObject *
_wrap_pango_tab_array_get_tabs(PyObject *self)
{
    PangoTabAlign *alignments;
    gint *locations, length, i;
    PyObject *ret;

    length = pango_tab_array_get_size(pyg_boxed_get(self, PangoTabArray));
    pango_tab_array_get_tabs(pyg_boxed_get(self, PangoTabArray),
			     &alignments, &locations);
    ret = PyTuple_New(length);
    for (i = 0; i < length; i++) {
	PyObject *item;

	item = Py_BuildValue("(ii)", (int)alignments[i], locations[i]);
	PyTuple_SetItem(ret, i, item);
    }
    return ret;
}
#line 1817 "pango.c"


static PyObject *
_wrap_pango_tab_array_get_positions_in_pixels(PyObject *self)
{
    int ret;

    ret = pango_tab_array_get_positions_in_pixels(pyg_boxed_get(self, PangoTabArray));
    return PyBool_FromLong(ret);

}

static PyMethodDef _PyPangoTabArray_methods[] = {
    { "copy", (PyCFunction)_wrap_pango_tab_array_copy, METH_NOARGS },
    { "get_size", (PyCFunction)_wrap_pango_tab_array_get_size, METH_NOARGS },
    { "resize", (PyCFunction)_wrap_pango_tab_array_resize, METH_VARARGS|METH_KEYWORDS },
    { "set_tab", (PyCFunction)_wrap_pango_tab_array_set_tab, METH_VARARGS|METH_KEYWORDS },
    { "get_tab", (PyCFunction)_wrap_pango_tab_array_get_tab, METH_VARARGS|METH_KEYWORDS },
    { "get_tabs", (PyCFunction)_wrap_pango_tab_array_get_tabs, METH_NOARGS },
    { "get_positions_in_pixels", (PyCFunction)_wrap_pango_tab_array_get_positions_in_pixels, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoTabArray_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.TabArray",			/* tp_name */
    sizeof(PyGBoxed),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoTabArray_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_pango_tab_array_new,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoContext ----------- */

#line 922 "pango.override"
static PyObject *
_wrap_pango_context_list_families(PyGObject *self)
{
    PangoFontFamily **families;
    gint n_families, i;
    PyObject *ret;

    pango_context_list_families(PANGO_CONTEXT(self->obj), &families,
				&n_families);
    ret = PyTuple_New(n_families);
    for (i = 0; i < n_families; i++) {
	PyObject *family;

	family = pygobject_new((GObject *)families[i]);
	PyTuple_SetItem(ret, i, family);
    }
    g_free(families);
    return ret;
}
#line 1910 "pango.c"


static PyObject *
_wrap_pango_context_load_font(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "desc", NULL };
    PyObject *py_desc;
    PangoFont *ret;
    PangoFontDescription *desc = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoContext.load_font", kwlist, &py_desc))
        return NULL;
    if (pyg_boxed_check(py_desc, PANGO_TYPE_FONT_DESCRIPTION))
        desc = pyg_boxed_get(py_desc, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc should be a PangoFontDescription");
        return NULL;
    }
    ret = pango_context_load_font(PANGO_CONTEXT(self->obj), desc);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_pango_context_load_fontset(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "desc", "language", NULL };
    PyObject *py_desc, *py_language;
    PangoFontset *ret;
    PangoFontDescription *desc = NULL;
    PangoLanguage *language = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OO:PangoContext.load_fontset", kwlist, &py_desc, &py_language))
        return NULL;
    if (pyg_boxed_check(py_desc, PANGO_TYPE_FONT_DESCRIPTION))
        desc = pyg_boxed_get(py_desc, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc should be a PangoFontDescription");
        return NULL;
    }
    if (pyg_boxed_check(py_language, PANGO_TYPE_LANGUAGE))
        language = pyg_boxed_get(py_language, PangoLanguage);
    else {
        PyErr_SetString(PyExc_TypeError, "language should be a PangoLanguage");
        return NULL;
    }
    ret = pango_context_load_fontset(PANGO_CONTEXT(self->obj), desc, language);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_pango_context_get_metrics(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "desc", "language", NULL };
    PyObject *py_desc, *py_language = Py_None;
    PangoFontDescription *desc = NULL;
    PangoLanguage *language = NULL;
    PangoFontMetrics *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O|O:PangoContext.get_metrics", kwlist, &py_desc, &py_language))
        return NULL;
    if (pyg_boxed_check(py_desc, PANGO_TYPE_FONT_DESCRIPTION))
        desc = pyg_boxed_get(py_desc, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc should be a PangoFontDescription");
        return NULL;
    }
    if (pyg_boxed_check(py_language, PANGO_TYPE_LANGUAGE))
        language = pyg_boxed_get(py_language, PangoLanguage);
    else if (py_language != Py_None) {
        PyErr_SetString(PyExc_TypeError, "language should be a PangoLanguage or None");
        return NULL;
    }
    ret = pango_context_get_metrics(PANGO_CONTEXT(self->obj), desc, language);
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_FONT_METRICS, ret, FALSE, TRUE);
}

static PyObject *
_wrap_pango_context_set_font_description(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "desc", NULL };
    PyObject *py_desc;
    PangoFontDescription *desc = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoContext.set_font_description", kwlist, &py_desc))
        return NULL;
    if (pyg_boxed_check(py_desc, PANGO_TYPE_FONT_DESCRIPTION))
        desc = pyg_boxed_get(py_desc, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc should be a PangoFontDescription");
        return NULL;
    }
    pango_context_set_font_description(PANGO_CONTEXT(self->obj), desc);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_context_get_font_description(PyGObject *self)
{
    PangoFontDescription *ret;

    ret = pango_context_get_font_description(PANGO_CONTEXT(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_FONT_DESCRIPTION, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pango_context_get_language(PyGObject *self)
{
    PangoLanguage *ret;

    ret = pango_context_get_language(PANGO_CONTEXT(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_LANGUAGE, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pango_context_set_language(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "language", NULL };
    PyObject *py_language;
    PangoLanguage *language = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoContext.set_language", kwlist, &py_language))
        return NULL;
    if (pyg_boxed_check(py_language, PANGO_TYPE_LANGUAGE))
        language = pyg_boxed_get(py_language, PangoLanguage);
    else {
        PyErr_SetString(PyExc_TypeError, "language should be a PangoLanguage");
        return NULL;
    }
    pango_context_set_language(PANGO_CONTEXT(self->obj), language);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_context_set_base_dir(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "direction", NULL };
    PangoDirection direction;
    PyObject *py_direction = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoContext.set_base_dir", kwlist, &py_direction))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_DIRECTION, py_direction, (gint *)&direction))
        return NULL;
    pango_context_set_base_dir(PANGO_CONTEXT(self->obj), direction);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_context_get_base_dir(PyGObject *self)
{
    gint ret;

    ret = pango_context_get_base_dir(PANGO_CONTEXT(self->obj));
    return pyg_enum_from_gtype(PANGO_TYPE_DIRECTION, ret);
}

static PyMethodDef _PyPangoContext_methods[] = {
    { "list_families", (PyCFunction)_wrap_pango_context_list_families, METH_NOARGS },
    { "load_font", (PyCFunction)_wrap_pango_context_load_font, METH_VARARGS|METH_KEYWORDS },
    { "load_fontset", (PyCFunction)_wrap_pango_context_load_fontset, METH_VARARGS|METH_KEYWORDS },
    { "get_metrics", (PyCFunction)_wrap_pango_context_get_metrics, METH_VARARGS|METH_KEYWORDS },
    { "set_font_description", (PyCFunction)_wrap_pango_context_set_font_description, METH_VARARGS|METH_KEYWORDS },
    { "get_font_description", (PyCFunction)_wrap_pango_context_get_font_description, METH_NOARGS },
    { "get_language", (PyCFunction)_wrap_pango_context_get_language, METH_NOARGS },
    { "set_language", (PyCFunction)_wrap_pango_context_set_language, METH_VARARGS|METH_KEYWORDS },
    { "set_base_dir", (PyCFunction)_wrap_pango_context_set_base_dir, METH_VARARGS|METH_KEYWORDS },
    { "get_base_dir", (PyCFunction)_wrap_pango_context_get_base_dir, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoContext_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.Context",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoContext_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFont ----------- */

static PyObject *
_wrap_pango_font_describe(PyGObject *self)
{
    PangoFontDescription *ret;

    ret = pango_font_describe(PANGO_FONT(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_FONT_DESCRIPTION, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pango_font_get_metrics(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "language", NULL };
    PyObject *py_language = Py_None;
    PangoLanguage *language = NULL;
    PangoFontMetrics *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|O:PangoFont.get_metrics", kwlist, &py_language))
        return NULL;
    if (pyg_boxed_check(py_language, PANGO_TYPE_LANGUAGE))
        language = pyg_boxed_get(py_language, PangoLanguage);
    else if (py_language != Py_None) {
        PyErr_SetString(PyExc_TypeError, "language should be a PangoLanguage or None");
        return NULL;
    }
    ret = pango_font_get_metrics(PANGO_FONT(self->obj), language);
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_FONT_METRICS, ret, TRUE, TRUE);
}

#line 943 "pango.override"
static PyObject *
_wrap_pango_font_get_glyph_extents(PyGObject *self, PyObject *args,
				   PyObject *kwargs)
{
    static char *kwlist[] = { "glyph", NULL };
    gint glyph;
    PangoRectangle ink_rect, logical_rect;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "i:PangoFont.get_glyph_extents", kwlist,
				     &glyph))
	return NULL;
    pango_font_get_glyph_extents(PANGO_FONT(self->obj), (PangoGlyph)glyph,
				 &ink_rect, &logical_rect);
    return Py_BuildValue("((iiii)(iiii))",
			 ink_rect.x, ink_rect.y,
			 ink_rect.width, ink_rect.height,
			 logical_rect.x, logical_rect.y,
			 logical_rect.width, logical_rect.height);
}
#line 2190 "pango.c"


static PyMethodDef _PyPangoFont_methods[] = {
    { "describe", (PyCFunction)_wrap_pango_font_describe, METH_NOARGS },
    { "get_metrics", (PyCFunction)_wrap_pango_font_get_metrics, METH_VARARGS|METH_KEYWORDS },
    { "get_glyph_extents", (PyCFunction)_wrap_pango_font_get_glyph_extents, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoFont_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.Font",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFont_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFontFace ----------- */

static PyObject *
_wrap_pango_font_face_describe(PyGObject *self)
{
    PangoFontDescription *ret;

    ret = pango_font_face_describe(PANGO_FONT_FACE(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_FONT_DESCRIPTION, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pango_font_face_get_face_name(PyGObject *self)
{
    const gchar *ret;

    ret = pango_font_face_get_face_name(PANGO_FONT_FACE(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

#line 1585 "pango.override"
static PyObject *
_wrap_pango_font_face_list_sizes(PyGObject *self)
{
    PyObject *py_sizes;
    int *sizes, n_sizes, i;

    pango_font_face_list_sizes(PANGO_FONT_FACE(self->obj), &sizes, &n_sizes);


    if (!sizes) {
	Py_INCREF(Py_None);
	return Py_None;
    }

    py_sizes = PyTuple_New(n_sizes);

    for (i = 0; i < n_sizes; i++)
	PyTuple_SetItem(py_sizes, i, PyInt_FromLong(sizes[i]));

    g_free(sizes);

    return py_sizes;
}
#line 2295 "pango.c"


static PyMethodDef _PyPangoFontFace_methods[] = {
    { "describe", (PyCFunction)_wrap_pango_font_face_describe, METH_NOARGS },
    { "get_face_name", (PyCFunction)_wrap_pango_font_face_get_face_name, METH_NOARGS },
    { "list_sizes", (PyCFunction)_wrap_pango_font_face_list_sizes, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoFontFace_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.FontFace",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFontFace_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFontFamily ----------- */

#line 965 "pango.override"
static PyObject *
_wrap_pango_font_family_list_faces(PyGObject *self)
{
    PangoFontFace **faces;
    gint n_faces, i;
    PyObject *ret;

    pango_font_family_list_faces(PANGO_FONT_FAMILY(self->obj),
				 &faces, &n_faces);
    ret = PyTuple_New(n_faces);
    for (i = 0; i < n_faces; i++) {
	PyObject *face;

	face = pygobject_new((GObject *)faces[i]);
	PyTuple_SetItem(ret, i, face);
    }
    g_free(faces);
    return ret;
}
#line 2374 "pango.c"


static PyObject *
_wrap_pango_font_family_get_name(PyGObject *self)
{
    const gchar *ret;

    ret = pango_font_family_get_name(PANGO_FONT_FAMILY(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_font_family_is_monospace(PyGObject *self)
{
    int ret;

    ret = pango_font_family_is_monospace(PANGO_FONT_FAMILY(self->obj));
    return PyBool_FromLong(ret);

}

static PyMethodDef _PyPangoFontFamily_methods[] = {
    { "list_faces", (PyCFunction)_wrap_pango_font_family_list_faces, METH_NOARGS },
    { "get_name", (PyCFunction)_wrap_pango_font_family_get_name, METH_NOARGS },
    { "is_monospace", (PyCFunction)_wrap_pango_font_family_is_monospace, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoFontFamily_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.FontFamily",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFontFamily_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFontMap ----------- */

static PyObject *
_wrap_pango_font_map_load_font(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "context", "desc", NULL };
    PyGObject *context;
    PyObject *py_desc;
    PangoFontDescription *desc = NULL;
    PangoFont *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O:PangoFontMap.load_font", kwlist, &PyPangoContext_Type, &context, &py_desc))
        return NULL;
    if (pyg_boxed_check(py_desc, PANGO_TYPE_FONT_DESCRIPTION))
        desc = pyg_boxed_get(py_desc, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc should be a PangoFontDescription");
        return NULL;
    }
    ret = pango_font_map_load_font(PANGO_FONT_MAP(self->obj), PANGO_CONTEXT(context->obj), desc);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_pango_font_map_load_fontset(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "context", "desc", "language", NULL };
    PyGObject *context;
    PyObject *py_desc, *py_language;
    PangoFontDescription *desc = NULL;
    PangoLanguage *language = NULL;
    PangoFontset *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!OO:PangoFontMap.load_fontset", kwlist, &PyPangoContext_Type, &context, &py_desc, &py_language))
        return NULL;
    if (pyg_boxed_check(py_desc, PANGO_TYPE_FONT_DESCRIPTION))
        desc = pyg_boxed_get(py_desc, PangoFontDescription);
    else {
        PyErr_SetString(PyExc_TypeError, "desc should be a PangoFontDescription");
        return NULL;
    }
    if (pyg_boxed_check(py_language, PANGO_TYPE_LANGUAGE))
        language = pyg_boxed_get(py_language, PangoLanguage);
    else {
        PyErr_SetString(PyExc_TypeError, "language should be a PangoLanguage");
        return NULL;
    }
    ret = pango_font_map_load_fontset(PANGO_FONT_MAP(self->obj), PANGO_CONTEXT(context->obj), desc, language);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 986 "pango.override"
static PyObject *
_wrap_pango_font_map_list_families(PyGObject *self)
{
    PangoFontFamily **families;
    gint n_families, i;
    PyObject *ret;

    pango_font_map_list_families(PANGO_FONT_MAP(self->obj), &families,
				 &n_families);
    ret = PyTuple_New(n_families);
    for (i = 0; i < n_families; i++) {
	PyObject *family;

	family = pygobject_new((GObject *)families[i]);
	PyTuple_SetItem(ret, i, family);
    }
    g_free(families);
    return ret;
}
#line 2526 "pango.c"


static PyObject *
_wrap_pango_font_map_get_shape_engine_type(PyGObject *self)
{
    const gchar *ret;

    ret = pango_font_map_get_shape_engine_type(PANGO_FONT_MAP(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyPangoFontMap_methods[] = {
    { "load_font", (PyCFunction)_wrap_pango_font_map_load_font, METH_VARARGS|METH_KEYWORDS },
    { "load_fontset", (PyCFunction)_wrap_pango_font_map_load_fontset, METH_VARARGS|METH_KEYWORDS },
    { "list_families", (PyCFunction)_wrap_pango_font_map_list_families, METH_NOARGS },
    { "get_shape_engine_type", (PyCFunction)_wrap_pango_font_map_get_shape_engine_type, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoFontMap_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.FontMap",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFontMap_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFontset ----------- */

static PyObject *
_wrap_pango_fontset_get_font(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "wc", NULL };
    int wc;
    PangoFont *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoFontset.get_font", kwlist, &wc))
        return NULL;
    ret = pango_fontset_get_font(PANGO_FONTSET(self->obj), wc);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_pango_fontset_get_metrics(PyGObject *self)
{
    PangoFontMetrics *ret;

    ret = pango_fontset_get_metrics(PANGO_FONTSET(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_FONT_METRICS, ret, TRUE, TRUE);
}

#line 1610 "pango.override"
static gboolean
pypango_fontset_foreach_cb(PangoFontset *fontset, PangoFont *font,
				 gpointer data)
{
    PyGILState_STATE state;
    PyGtkCustomNotify *cunote = data;
    PyObject *retobj, *py_font, *py_fontset;
    gboolean ret = FALSE;
    
    state = pyg_gil_state_ensure();

    py_fontset = pygobject_new((GObject *)fontset);
    py_font = pygobject_new((GObject *)font);

    if (cunote->data)
	retobj = PyObject_CallFunction(cunote->func, "NNO", py_fontset,
				       py_font, cunote->data);
    else
	retobj = PyObject_CallFunction(cunote->func, "NN", py_fontset,
				       py_font);

    if (retobj != NULL) {
	ret = PyObject_IsTrue(retobj);
        Py_DECREF(retobj);
    } else {
        PyErr_Print();
    }

    pyg_gil_state_release(state);
    return ret;
}
static PyObject *
_wrap_pango_fontset_foreach(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "func", "data", NULL };
    PyObject *py_func, *py_data = NULL;
    PyGtkCustomNotify cunote;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "O|O:pango.Fontset.fforeach",
				     kwlist, &py_func, &py_data))
	return NULL;

    if (!PyCallable_Check(py_func)) {
        PyErr_SetString(PyExc_TypeError, "func must be callable");
        return NULL;
    }

    cunote.func = py_func;
    cunote.data = py_data;
    Py_INCREF(cunote.func);
    Py_XINCREF(cunote.data);

    pango_fontset_foreach(PANGO_FONTSET(self->obj),
			  pypango_fontset_foreach_cb,
			  (gpointer)&cunote);

    Py_DECREF(cunote.func);
    Py_XDECREF(cunote.data);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 2686 "pango.c"


static PyMethodDef _PyPangoFontset_methods[] = {
    { "get_font", (PyCFunction)_wrap_pango_fontset_get_font, METH_VARARGS|METH_KEYWORDS },
    { "get_metrics", (PyCFunction)_wrap_pango_fontset_get_metrics, METH_NOARGS },
    { "foreach", (PyCFunction)_wrap_pango_fontset_foreach, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoFontset_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.Fontset",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFontset_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoFontsetSimple ----------- */

static int
_wrap_pango_fontset_simple_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "language", NULL };
    PyObject *py_language;
    PangoLanguage *language = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoFontsetSimple.__init__", kwlist, &py_language))
        return -1;
    if (pyg_boxed_check(py_language, PANGO_TYPE_LANGUAGE))
        language = pyg_boxed_get(py_language, PangoLanguage);
    else {
        PyErr_SetString(PyExc_TypeError, "language should be a PangoLanguage");
        return -1;
    }
    self->obj = (GObject *)pango_fontset_simple_new(language);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PangoFontsetSimple object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_pango_fontset_simple_append(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "font", NULL };
    PyGObject *font;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:PangoFontsetSimple.append", kwlist, &PyPangoFont_Type, &font))
        return NULL;
    pango_fontset_simple_append(PANGO_FONTSET_SIMPLE(self->obj), PANGO_FONT(font->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_fontset_simple_size(PyGObject *self)
{
    int ret;

    ret = pango_fontset_simple_size(PANGO_FONTSET_SIMPLE(self->obj));
    return PyInt_FromLong(ret);
}

static PyMethodDef _PyPangoFontsetSimple_methods[] = {
    { "append", (PyCFunction)_wrap_pango_fontset_simple_append, METH_VARARGS|METH_KEYWORDS },
    { "size", (PyCFunction)_wrap_pango_fontset_simple_size, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoFontsetSimple_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.FontsetSimple",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoFontsetSimple_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_pango_fontset_simple_new,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PangoLayout ----------- */

static int
_wrap_pango_layout_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "context", NULL };
    PyGObject *context;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:PangoLayout.__init__", kwlist, &PyPangoContext_Type, &context))
        return -1;
    self->obj = (GObject *)pango_layout_new(PANGO_CONTEXT(context->obj));

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PangoLayout object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_pango_layout_copy(PyGObject *self)
{
    PangoLayout *ret;

    ret = pango_layout_copy(PANGO_LAYOUT(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_pango_layout_get_context(PyGObject *self)
{
    PangoContext *ret;

    ret = pango_layout_get_context(PANGO_LAYOUT(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_pango_layout_set_attributes(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "attrs", NULL };
    PyObject *py_attrs;
    PangoAttrList *attrs = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoLayout.set_attributes", kwlist, &py_attrs))
        return NULL;
    if (pyg_boxed_check(py_attrs, PANGO_TYPE_ATTR_LIST))
        attrs = pyg_boxed_get(py_attrs, PangoAttrList);
    else {
        PyErr_SetString(PyExc_TypeError, "attrs should be a PangoAttrList");
        return NULL;
    }
    pango_layout_set_attributes(PANGO_LAYOUT(self->obj), attrs);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_attributes(PyGObject *self)
{
    PangoAttrList *ret;

    ret = pango_layout_get_attributes(PANGO_LAYOUT(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_ATTR_LIST, ret, TRUE, TRUE);
}

#line 1364 "pango.override"
static PyObject *
_wrap_pango_layout_set_text(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "text", NULL };
    char *text;
    gint length;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s#:PangoLayout.set_text",
				     kwlist, &text, &length))
        return NULL;
    pango_layout_set_text(PANGO_LAYOUT(self->obj), text, length);
    Py_INCREF(Py_None);
    return Py_None;
}
#line 2930 "pango.c"


static PyObject *
_wrap_pango_layout_get_text(PyGObject *self)
{
    const gchar *ret;

    ret = pango_layout_get_text(PANGO_LAYOUT(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

#line 1097 "pango.override"
static PyObject *
_wrap_pango_layout_set_markup(PyGObject *self, PyObject *args,PyObject *kwargs)
{
    static char *kwlist[] = { "markup", NULL };
    char *markup;
    gint length;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s#:PangoLayout.set_markup",
				     kwlist, &markup, &length))
	return NULL;

    pango_layout_set_markup(PANGO_LAYOUT(self->obj), markup, length);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 2962 "pango.c"


#line 1115 "pango.override"
static PyObject *
_wrap_pango_layout_set_markup_with_accel(PyGObject *self, PyObject *args,
					 PyObject *kwargs)
{
    static char *kwlist[] = { "markup", "accel_marker", NULL };
    char *markup;
    gint length, accel_length;
    Py_UNICODE *accel_marker, pychr;
    gunichar accel_char;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "s#u#:PangoLayout.set_markup_with_accel",
				     kwlist, &markup, &length,
				     &accel_marker, &accel_length))
	return NULL;
    if (accel_length != 1) {
	PyErr_SetString(PyExc_TypeError, "accel_marker must be a unicode string of length 1");
	return NULL;
    }
    pango_layout_set_markup_with_accel(PANGO_LAYOUT(self->obj), markup, length,
				       (gunichar)accel_marker[0], &accel_char);

#if !defined(Py_UNICODE_SIZE) || Py_UNICODE_SIZE == 2
    if (accel_char >= 0xffff) {
	PyErr_SetString(PyExc_ValueError, "unicode character is too big to fit in a 16-bit unicode character");
	return NULL;
    }
#endif
    pychr = (Py_UNICODE)accel_char;
    return PyUnicode_FromUnicode(&pychr, 1);
}
#line 2997 "pango.c"


static PyObject *
_wrap_pango_layout_set_font_description(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "desc", NULL };
    PyObject *py_desc = Py_None;
    PangoFontDescription *desc = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoLayout.set_font_description", kwlist, &py_desc))
        return NULL;
    if (pyg_boxed_check(py_desc, PANGO_TYPE_FONT_DESCRIPTION))
        desc = pyg_boxed_get(py_desc, PangoFontDescription);
    else if (py_desc != Py_None) {
        PyErr_SetString(PyExc_TypeError, "desc should be a PangoFontDescription or None");
        return NULL;
    }
    pango_layout_set_font_description(PANGO_LAYOUT(self->obj), desc);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_set_width(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", NULL };
    int width;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoLayout.set_width", kwlist, &width))
        return NULL;
    pango_layout_set_width(PANGO_LAYOUT(self->obj), width);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_width(PyGObject *self)
{
    int ret;

    ret = pango_layout_get_width(PANGO_LAYOUT(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_layout_set_wrap(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "wrap", NULL };
    PyObject *py_wrap = NULL;
    PangoWrapMode wrap;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoLayout.set_wrap", kwlist, &py_wrap))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_WRAP_MODE, py_wrap, (gint *)&wrap))
        return NULL;
    pango_layout_set_wrap(PANGO_LAYOUT(self->obj), wrap);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_wrap(PyGObject *self)
{
    gint ret;

    ret = pango_layout_get_wrap(PANGO_LAYOUT(self->obj));
    return pyg_enum_from_gtype(PANGO_TYPE_WRAP_MODE, ret);
}

static PyObject *
_wrap_pango_layout_set_indent(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "indent", NULL };
    int indent;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoLayout.set_indent", kwlist, &indent))
        return NULL;
    pango_layout_set_indent(PANGO_LAYOUT(self->obj), indent);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_indent(PyGObject *self)
{
    int ret;

    ret = pango_layout_get_indent(PANGO_LAYOUT(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_layout_set_spacing(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "spacing", NULL };
    int spacing;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoLayout.set_spacing", kwlist, &spacing))
        return NULL;
    pango_layout_set_spacing(PANGO_LAYOUT(self->obj), spacing);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_spacing(PyGObject *self)
{
    int ret;

    ret = pango_layout_get_spacing(PANGO_LAYOUT(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_pango_layout_set_justify(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "justify", NULL };
    int justify;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoLayout.set_justify", kwlist, &justify))
        return NULL;
    pango_layout_set_justify(PANGO_LAYOUT(self->obj), justify);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_justify(PyGObject *self)
{
    int ret;

    ret = pango_layout_get_justify(PANGO_LAYOUT(self->obj));
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_pango_layout_set_auto_dir(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "auto_dir", NULL };
    int auto_dir;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoLayout.set_auto_dir", kwlist, &auto_dir))
        return NULL;
    pango_layout_set_auto_dir(PANGO_LAYOUT(self->obj), auto_dir);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_auto_dir(PyGObject *self)
{
    int ret;

    ret = pango_layout_get_auto_dir(PANGO_LAYOUT(self->obj));
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_pango_layout_set_alignment(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "alignment", NULL };
    PyObject *py_alignment = NULL;
    PangoAlignment alignment;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoLayout.set_alignment", kwlist, &py_alignment))
        return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_ALIGNMENT, py_alignment, (gint *)&alignment))
        return NULL;
    pango_layout_set_alignment(PANGO_LAYOUT(self->obj), alignment);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_alignment(PyGObject *self)
{
    gint ret;

    ret = pango_layout_get_alignment(PANGO_LAYOUT(self->obj));
    return pyg_enum_from_gtype(PANGO_TYPE_ALIGNMENT, ret);
}

static PyObject *
_wrap_pango_layout_set_tabs(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "tabs", NULL };
    PyObject *py_tabs = Py_None;
    PangoTabArray *tabs = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:PangoLayout.set_tabs", kwlist, &py_tabs))
        return NULL;
    if (pyg_boxed_check(py_tabs, PANGO_TYPE_TAB_ARRAY))
        tabs = pyg_boxed_get(py_tabs, PangoTabArray);
    else if (py_tabs != Py_None) {
        PyErr_SetString(PyExc_TypeError, "tabs should be a PangoTabArray or None");
        return NULL;
    }
    pango_layout_set_tabs(PANGO_LAYOUT(self->obj), tabs);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_tabs(PyGObject *self)
{
    PangoTabArray *ret;

    ret = pango_layout_get_tabs(PANGO_LAYOUT(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_TAB_ARRAY, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pango_layout_set_single_paragraph_mode(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "setting", NULL };
    int setting;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PangoLayout.set_single_paragraph_mode", kwlist, &setting))
        return NULL;
    pango_layout_set_single_paragraph_mode(PANGO_LAYOUT(self->obj), setting);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_pango_layout_get_single_paragraph_mode(PyGObject *self)
{
    int ret;

    ret = pango_layout_get_single_paragraph_mode(PANGO_LAYOUT(self->obj));
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_pango_layout_context_changed(PyGObject *self)
{
    pango_layout_context_changed(PANGO_LAYOUT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

#line 1148 "pango.override"
static PyObject *
_wrap_pango_layout_index_to_pos(PyGObject *self, PyObject *args,
				PyObject *kwargs)
{
    static char *kwlist[] = { "index", NULL };
    gint index;
    PangoRectangle pos;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "i:PangoLayout.index_to_pos", kwlist,
				     &index))
	return NULL;

    pango_layout_index_to_pos(PANGO_LAYOUT(self->obj), index, &pos);
    return Py_BuildValue("(iiii)", pos.x, pos.y, pos.width, pos.height);
}
#line 3260 "pango.c"


#line 1166 "pango.override"
static PyObject *
_wrap_pango_layout_get_cursor_pos(PyGObject *self, PyObject *args,
				  PyObject *kwargs)
{
    static char *kwlist[] = { "index", NULL };
    gint index;
    PangoRectangle strong_pos, weak_pos;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "i:PangoLayout.get_cursor_pos", kwlist,
				     &index))
	return NULL;

    pango_layout_get_cursor_pos(PANGO_LAYOUT(self->obj), index,
				&strong_pos, &weak_pos);
    return Py_BuildValue("((iiii)(iiii))",
			 strong_pos.x, strong_pos.y,
			 strong_pos.width, strong_pos.height,
			 weak_pos.x, weak_pos.y,
			 weak_pos.width, weak_pos.height);
}
#line 3285 "pango.c"


#line 1189 "pango.override"
static PyObject *
_wrap_pango_layout_move_cursor_visually(PyGObject *self, PyObject *args,
					PyObject *kwargs)
{
    static char *kwlist[] = { "strong", "old_index", "old_trailing", "direction", NULL };
    gboolean strong;
    gint old_index, old_trailing, direction, new_index = 0, new_trailing = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "iiii:PangoLayout.move_cursor_visually",
				     kwlist, &strong, &old_index,
				     &old_trailing, &direction))
	return NULL;

    pango_layout_move_cursor_visually(PANGO_LAYOUT(self->obj), strong,
				      old_index, old_trailing, direction,
				      &new_index, &new_trailing);
    return Py_BuildValue("(ii)", new_index, new_trailing);
}
#line 3308 "pango.c"


#line 1210 "pango.override"
static PyObject *
_wrap_pango_layout_xy_to_index(PyGObject *self, PyObject *args,
			       PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", NULL };
    gint x, y, index, trailing;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "ii:PangoLayout.xy_to_index", kwlist,
				     &x, &y))
	return NULL;

    pango_layout_xy_to_index(PANGO_LAYOUT(self->obj), x, y, &index, &trailing);

    return Py_BuildValue("(ii)", index, trailing);
}
#line 3328 "pango.c"


#line 1228 "pango.override"
static PyObject *
_wrap_pango_layout_get_extents(PyGObject *self)
{
    PangoRectangle ink_rect, logical_rect;

    pango_layout_get_extents(PANGO_LAYOUT(self->obj),
			     &ink_rect, &logical_rect);

    return Py_BuildValue("((iiii)(iiii))",
			 ink_rect.x, ink_rect.y,
			 ink_rect.width, ink_rect.height,
			 logical_rect.x, logical_rect.y,
			 logical_rect.width, logical_rect.height);
}
#line 3346 "pango.c"


#line 1244 "pango.override"
static PyObject *
_wrap_pango_layout_get_pixel_extents(PyGObject *self)
{
    PangoRectangle ink_rect, logical_rect;

    pango_layout_get_pixel_extents(PANGO_LAYOUT(self->obj),
				   &ink_rect, &logical_rect);

    return Py_BuildValue("((iiii)(iiii))",
			 ink_rect.x, ink_rect.y,
			 ink_rect.width, ink_rect.height,
			 logical_rect.x, logical_rect.y,
			 logical_rect.width, logical_rect.height);
}
#line 3364 "pango.c"


#line 1260 "pango.override"
static PyObject *
_wrap_pango_layout_get_size(PyGObject *self)
{
    gint width, height;

    pango_layout_get_size(PANGO_LAYOUT(self->obj), &width, &height);

    return Py_BuildValue("(ii)", width, height);
}
#line 3377 "pango.c"


#line 1271 "pango.override"
static PyObject *
_wrap_pango_layout_get_pixel_size(PyGObject *self)
{
    gint width, height;

    pango_layout_get_pixel_size(PANGO_LAYOUT(self->obj), &width, &height);

    return Py_BuildValue("(ii)", width, height);
}
#line 3390 "pango.c"


static PyObject *
_wrap_pango_layout_get_line_count(PyGObject *self)
{
    int ret;

    ret = pango_layout_get_line_count(PANGO_LAYOUT(self->obj));
    return PyInt_FromLong(ret);
}

static PyMethodDef _PyPangoLayout_methods[] = {
    { "copy", (PyCFunction)_wrap_pango_layout_copy, METH_NOARGS },
    { "get_context", (PyCFunction)_wrap_pango_layout_get_context, METH_NOARGS },
    { "set_attributes", (PyCFunction)_wrap_pango_layout_set_attributes, METH_VARARGS|METH_KEYWORDS },
    { "get_attributes", (PyCFunction)_wrap_pango_layout_get_attributes, METH_NOARGS },
    { "set_text", (PyCFunction)_wrap_pango_layout_set_text, METH_VARARGS|METH_KEYWORDS },
    { "get_text", (PyCFunction)_wrap_pango_layout_get_text, METH_NOARGS },
    { "set_markup", (PyCFunction)_wrap_pango_layout_set_markup, METH_VARARGS|METH_KEYWORDS },
    { "set_markup_with_accel", (PyCFunction)_wrap_pango_layout_set_markup_with_accel, METH_VARARGS|METH_KEYWORDS },
    { "set_font_description", (PyCFunction)_wrap_pango_layout_set_font_description, METH_VARARGS|METH_KEYWORDS },
    { "set_width", (PyCFunction)_wrap_pango_layout_set_width, METH_VARARGS|METH_KEYWORDS },
    { "get_width", (PyCFunction)_wrap_pango_layout_get_width, METH_NOARGS },
    { "set_wrap", (PyCFunction)_wrap_pango_layout_set_wrap, METH_VARARGS|METH_KEYWORDS },
    { "get_wrap", (PyCFunction)_wrap_pango_layout_get_wrap, METH_NOARGS },
    { "set_indent", (PyCFunction)_wrap_pango_layout_set_indent, METH_VARARGS|METH_KEYWORDS },
    { "get_indent", (PyCFunction)_wrap_pango_layout_get_indent, METH_NOARGS },
    { "set_spacing", (PyCFunction)_wrap_pango_layout_set_spacing, METH_VARARGS|METH_KEYWORDS },
    { "get_spacing", (PyCFunction)_wrap_pango_layout_get_spacing, METH_NOARGS },
    { "set_justify", (PyCFunction)_wrap_pango_layout_set_justify, METH_VARARGS|METH_KEYWORDS },
    { "get_justify", (PyCFunction)_wrap_pango_layout_get_justify, METH_NOARGS },
    { "set_auto_dir", (PyCFunction)_wrap_pango_layout_set_auto_dir, METH_VARARGS|METH_KEYWORDS },
    { "get_auto_dir", (PyCFunction)_wrap_pango_layout_get_auto_dir, METH_NOARGS },
    { "set_alignment", (PyCFunction)_wrap_pango_layout_set_alignment, METH_VARARGS|METH_KEYWORDS },
    { "get_alignment", (PyCFunction)_wrap_pango_layout_get_alignment, METH_NOARGS },
    { "set_tabs", (PyCFunction)_wrap_pango_layout_set_tabs, METH_VARARGS|METH_KEYWORDS },
    { "get_tabs", (PyCFunction)_wrap_pango_layout_get_tabs, METH_NOARGS },
    { "set_single_paragraph_mode", (PyCFunction)_wrap_pango_layout_set_single_paragraph_mode, METH_VARARGS|METH_KEYWORDS },
    { "get_single_paragraph_mode", (PyCFunction)_wrap_pango_layout_get_single_paragraph_mode, METH_NOARGS },
    { "context_changed", (PyCFunction)_wrap_pango_layout_context_changed, METH_NOARGS },
    { "index_to_pos", (PyCFunction)_wrap_pango_layout_index_to_pos, METH_VARARGS|METH_KEYWORDS },
    { "get_cursor_pos", (PyCFunction)_wrap_pango_layout_get_cursor_pos, METH_VARARGS|METH_KEYWORDS },
    { "move_cursor_visually", (PyCFunction)_wrap_pango_layout_move_cursor_visually, METH_VARARGS|METH_KEYWORDS },
    { "xy_to_index", (PyCFunction)_wrap_pango_layout_xy_to_index, METH_VARARGS|METH_KEYWORDS },
    { "get_extents", (PyCFunction)_wrap_pango_layout_get_extents, METH_NOARGS },
    { "get_pixel_extents", (PyCFunction)_wrap_pango_layout_get_pixel_extents, METH_NOARGS },
    { "get_size", (PyCFunction)_wrap_pango_layout_get_size, METH_NOARGS },
    { "get_pixel_size", (PyCFunction)_wrap_pango_layout_get_pixel_size, METH_NOARGS },
    { "get_line_count", (PyCFunction)_wrap_pango_layout_get_line_count, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPangoLayout_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "pango.Layout",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,	/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    (PyBufferProcs*)0,	/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,	/* tp_traverse */
    (inquiry)0,		/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPangoLayout_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_pango_layout_new,		/* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_pango_attr_type_register(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:pango_attr_type_register", kwlist, &name))
        return NULL;
    ret = pango_attr_type_register(name);
    return pyg_enum_from_gtype(PANGO_TYPE_ATTR_TYPE, ret);
}

#line 515 "pango.override"
static PyObject *
_wrap_pango_attr_language_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "language", "start_index", "end_index", NULL };
    char *slanguage;
    PangoLanguage *language;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|ii:PangoAttrLanguage",
				     kwlist, &slanguage, &start, &end))
	return NULL;

    language = pango_language_from_string(slanguage);

    return pypango_attr_new(pango_attr_language_new(language), start, end);
}
#line 3522 "pango.c"


#line 533 "pango.override"
static PyObject *
_wrap_pango_attr_family_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "family", "start_index", "end_index", NULL };
    char *family;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|ii:PangoAttrFamily",
				     kwlist, &family, &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_family_new(family), start, end);
}
#line 3539 "pango.c"


#line 548 "pango.override"
static PyObject *
_wrap_pango_attr_foreground_new(PyObject *self,PyObject *args,PyObject *kwargs)
{
    static char *kwlist[] = { "red", "green", "blue", "start_index",
			      "end_index", NULL };
    guint16 red, green, blue;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "HHH|ii:PangoAttrForeground",
				     kwlist, &red, &green, &blue,
				     &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_foreground_new(red, green, blue),
			    start, end);
}
#line 3560 "pango.c"


#line 567 "pango.override"
static PyObject *
_wrap_pango_attr_background_new(PyObject *self,PyObject *args,PyObject *kwargs)
{
    static char *kwlist[] = { "red", "green", "blue", "start_index",
			      "end_index", NULL };
    guint16 red, green, blue;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "HHH|ii:PangoAttrBackground",
				     kwlist, &red, &green, &blue,
				     &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_background_new(red, green, blue),
			    start, end);
}
#line 3581 "pango.c"


#line 586 "pango.override"
static PyObject *
_wrap_pango_attr_size_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "size", "start_index", "end_index", NULL };
    int size;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i|ii:PangoAttrSize",
				     kwlist, &size, &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_size_new(size), start, end);
}
#line 3598 "pango.c"


#line 601 "pango.override"
static PyObject *
_wrap_pango_attr_style_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "style", "start_index", "end_index", NULL };
    PyObject *py_style;
    PangoStyle style;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O|ii:PangoAttrStyle",
				     kwlist, &py_style, &start, &end))
	return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_STYLE, py_style, (gint *)&style))
	return NULL;

    return pypango_attr_new(pango_attr_style_new(style), start, end);
}
#line 3618 "pango.c"


#line 619 "pango.override"
static PyObject *
_wrap_pango_attr_weight_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "weight", "start_index", "end_index", NULL };
    PyObject *py_weight;
    PangoWeight weight;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O|ii:PangoAttrWeight",
				     kwlist, &py_weight, &start, &end))
	return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_WEIGHT, py_weight, (gint *)&weight))
	return NULL;

    return pypango_attr_new(pango_attr_weight_new(weight), start, end);
}
#line 3638 "pango.c"


#line 637 "pango.override"
static PyObject *
_wrap_pango_attr_variant_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "variant", "start_index", "end_index", NULL };
    PyObject *py_variant;
    PangoVariant variant;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O|ii:PangoAttrVariant",
				     kwlist, &py_variant, &start, &end))
	return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_VARIANT, py_variant, (gint *)&variant))
	return NULL;

    return pypango_attr_new(pango_attr_variant_new(variant), start, end);
}
#line 3658 "pango.c"


#line 655 "pango.override"
static PyObject *
_wrap_pango_attr_stretch_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "stretch", "start_index", "end_index", NULL };
    PyObject *py_stretch;
    PangoStretch stretch;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O|ii:PangoAttrStretch",
				     kwlist, &py_stretch, &start, &end))
	return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_STRETCH, py_stretch, (gint *)&stretch))
	return NULL;

    return pypango_attr_new(pango_attr_stretch_new(stretch), start, end);
}
#line 3678 "pango.c"


#line 673 "pango.override"
static PyObject *
_wrap_pango_attr_font_desc_new(PyObject *self, PyObject *args,PyObject *kwargs)
{
    static char *kwlist[] = { "desc", "start_index", "end_index", NULL };
    PyObject *font_desc;
    PangoFontDescription *desc;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O|ii:PangoAttrFontDesc",
				     kwlist, &font_desc, &start, &end))
	return NULL;
    if (!pyg_boxed_check(font_desc, PANGO_TYPE_FONT_DESCRIPTION)) {
	PyErr_SetString(PyExc_TypeError,"desc must be a PangoFontDescription");
	return NULL;
    }
    desc = pyg_boxed_get(font_desc, PangoFontDescription);
    return pypango_attr_new(pango_attr_font_desc_new(desc), start, end);
}
#line 3700 "pango.c"


#line 693 "pango.override"
static PyObject *
_wrap_pango_attr_underline_new(PyObject *self, PyObject *args,PyObject *kwargs)
{
    static char *kwlist[] = { "underline", "start_index", "end_index", NULL };
    PyObject *py_underline;
    PangoUnderline underline;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O|ii:PangoAttrUnderline",
				     kwlist, &py_underline, &start, &end))
	return NULL;
    if (pyg_enum_get_value(PANGO_TYPE_UNDERLINE, py_underline,
			   (gint *)&underline))
	return NULL;

    return pypango_attr_new(pango_attr_underline_new(underline), start, end);
}
#line 3721 "pango.c"


#line 712 "pango.override"
static PyObject *
_wrap_pango_attr_strikethrough_new(PyObject *self, PyObject *args,
				   PyObject *kwargs)
{
    static char *kwlist[] = { "strikethrough", "start_index",
			      "end_index", NULL };
    gboolean strikethrough;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "i|ii:PangoAttrStrikethrough",
				     kwlist, &strikethrough, &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_strikethrough_new(strikethrough),
			    start, end);
}
#line 3742 "pango.c"


#line 731 "pango.override"
static PyObject *
_wrap_pango_attr_rise_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "rise", "start_index", "end_index", NULL };
    gint rise;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i|ii:PangoAttrRise",
				     kwlist, &rise, &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_rise_new(rise), start, end);
}
#line 3759 "pango.c"


#line 746 "pango.override"
static PyObject *
_wrap_pango_attr_shape_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "ink_rect", "logical_rect", "start_index",
			      "end_index", NULL };
    PangoRectangle ink_rect, logical_rect;
    PyObject *py_ink_rect, *py_logical_rect;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "OO|ii:PangoAttrShape", kwlist,
				     &py_ink_rect, &py_logical_rect,
				     &start, &end))
	return NULL;

    if (!PyTuple_Check(py_ink_rect)
	|| !PyArg_ParseTuple(py_ink_rect, "iiii",
			     &ink_rect.x, &ink_rect.y,
			     &ink_rect.width, &ink_rect.height)) {
	PyErr_Clear();
	PyErr_SetString(PyExc_TypeError,
			"ink_rect must be a 4-tuple of integers");
	return NULL;
    }

    if (!PyTuple_Check(py_logical_rect)
	|| !PyArg_ParseTuple(py_logical_rect, "iiii",
			     &logical_rect.x, &logical_rect.y,
			     &logical_rect.width,&logical_rect.height)) {
	PyErr_Clear();
	PyErr_SetString(PyExc_TypeError,
			"logical_rect must be a 4-tuple of integers");
	return NULL;
    }

    return pypango_attr_new(pango_attr_shape_new(&ink_rect, &logical_rect),
			    start, end);
}
#line 3801 "pango.c"


#line 786 "pango.override"
static PyObject *
_wrap_pango_attr_scale_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "scale", "start_index", "end_index", NULL };
    double scale;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "d|ii:PangoAttrScale",
				     kwlist, &scale, &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_scale_new(scale), start, end);
}
#line 3818 "pango.c"


#line 1501 "pango.override"
static PyObject *
_wrap_pango_attr_fallback_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "fallback", "start_index", "end_index", NULL };
    gboolean fallback;
    guint start = 0, end = 1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i|ii:PangoAttrFallback",
				     kwlist, &fallback, &start, &end))
	return NULL;

    return pypango_attr_new(pango_attr_fallback_new(fallback),
			    start, end);
}
#line 3836 "pango.c"


#line 1282 "pango.override"
static PyObject *
_wrap_pango_parse_markup(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "markup_text", "accel_marker", NULL };
    char *markup_text, *text = NULL;
    gint length;
    Py_UNICODE *py_accel_marker, py_accel_char;
    gint py_accel_marker_len;
    gunichar accel_marker, accel_char = 0;
    PangoAttrList *attr_list = NULL;
    GError *error = NULL;
    gboolean ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s#u#:pango.parse_markup",
				     kwlist, &markup_text, &length,
				     &py_accel_marker, &py_accel_marker_len))
	return NULL;
    if (py_accel_marker_len != 1) {
	PyErr_SetString(PyExc_TypeError, "accel_mark must be one character");
	return NULL;
    }
    accel_marker = py_accel_marker[0];
    ret = pango_parse_markup(markup_text, length, accel_marker,
			     &attr_list, &text, &accel_char, &error);
    if (pyg_error_check(&error))
	return NULL;

#if !defined(Py_UNICODE_SIZE) || Py_UNICODE_SIZE == 2
    if (accel_char >= 0xffff) {
	PyErr_SetString(PyExc_ValueError, "unicode character is too big to fit in a 16-bit unicode character");
	return NULL;
    }
#endif
    py_accel_char = (Py_UNICODE)accel_char;

    py_ret = Py_BuildValue("(Nsu#)", pyg_boxed_new(PANGO_TYPE_ATTR_LIST,
						   attr_list, FALSE, TRUE),
			   text, &py_accel_char, 1);
    g_free(text);
    return py_ret;
}
#line 3882 "pango.c"


#line 1675 "pango.override"
static PyObject *
_wrap_pango_language_from_string1(PyGObject *self, PyObject *args,
			       PyObject *kwargs)
{
    static char *kwlist[] = { "language", NULL };
    char *language;
    PangoLanguage *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "s:pango_language_from_string",
				     kwlist, &language))
        return NULL;
    if (PyErr_Warn(PyExc_DeprecationWarning,
		   "use pango.Language instead") < 0)
        return NULL;

    ret = pango_language_from_string(language);
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PANGO_TYPE_LANGUAGE, ret, TRUE, TRUE);
}

#line 3907 "pango.c"


#line 1698 "pango.override"
static PyObject *
_wrap_pango_language_matches1(PyGObject *self, PyObject *args,
			       PyObject *kwargs)
{
    static char *kwlist[] = { "language", "range_list", NULL };
    PyObject *py_language = Py_None;
    char *range_list;
    PangoLanguage *language = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "Os:pango_language_matches",
				     kwlist, &py_language, &range_list))
        return NULL;
    if (PyErr_Warn(PyExc_DeprecationWarning,
		   "use pango.Language.matches instead") < 0)
        return NULL;

    if (pyg_boxed_check(py_language, PANGO_TYPE_LANGUAGE))
        language = pyg_boxed_get(py_language, PangoLanguage);
    else if (py_language != Py_None) {
        PyErr_SetString(PyExc_TypeError,
			"language should be a PangoLanguage or None");
        return NULL;
    }

    return PyBool_FromLong(pango_language_matches(language, range_list));
}
#line 3938 "pango.c"


static PyObject *
_wrap_PANGO_PIXELS(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "size", NULL };
    int size, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:PIXELS", kwlist, &size))
        return NULL;
    ret = PANGO_PIXELS(size);
    return PyInt_FromLong(ret);
}

#line 1417 "pango.override"
static PyObject *
_wrap_PANGO_ASCENT(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "rect", NULL };
    int ret;
    PangoRectangle rect;
    PyObject *py_rect;

    if (PyArg_ParseTupleAndKeywords(args, kwargs, "O!:ASCENT",
				     kwlist, &PyTuple_Type, &py_rect)
	&& PyArg_ParseTuple(py_rect, "iiii:ASCENT", &rect.x, &rect.y,
			     &rect.width, &rect.height)) {
	ret = PANGO_ASCENT(rect);
	return PyInt_FromLong(ret);
    }
    PyErr_Clear();
    PyErr_SetString(PyExc_ValueError, "rect must be a 4-tuple of integers");
    return NULL;
}
#line 3973 "pango.c"


#line 1438 "pango.override"
static PyObject *
_wrap_PANGO_DESCENT(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "rect", NULL };
    int ret;
    PangoRectangle rect;
    PyObject *py_rect;

    if (PyArg_ParseTupleAndKeywords(args, kwargs, "O!:DESCENT",
				     kwlist, &PyTuple_Type, &py_rect)
	&& PyArg_ParseTuple(py_rect, "iiii:DESCENT", &rect.x, &rect.y,
			     &rect.width, &rect.height)) {
	ret = PANGO_DESCENT(rect);
	return PyInt_FromLong(ret);
    }
    PyErr_Clear();
    PyErr_SetString(PyExc_ValueError, "rect must be a 4-tuple of integers");
    return NULL;
}
#line 3996 "pango.c"


#line 1459 "pango.override"
static PyObject *
_wrap_PANGO_LBEARING(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "rect", NULL };
    int ret;
    PangoRectangle rect;
    PyObject *py_rect;

    if (PyArg_ParseTupleAndKeywords(args, kwargs, "O!:LBEARING",
				     kwlist, &PyTuple_Type, &py_rect)
	&& PyArg_ParseTuple(py_rect, "iiii:LBEARING", &rect.x, &rect.y,
			     &rect.width, &rect.height)) {
	ret = PANGO_LBEARING(rect);
	return PyInt_FromLong(ret);
    }
    PyErr_Clear();
    PyErr_SetString(PyExc_ValueError, "rect must be a 4-tuple of integers");
    return NULL;
}
#line 4019 "pango.c"


#line 1480 "pango.override"
static PyObject *
_wrap_PANGO_RBEARING(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "rect", NULL };
    int ret;
    PangoRectangle rect;
    PyObject *py_rect;

    if (PyArg_ParseTupleAndKeywords(args, kwargs, "O!:RBEARING",
				     kwlist, &PyTuple_Type, &py_rect)
	&& PyArg_ParseTuple(py_rect, "iiii:RBEARING", &rect.x, &rect.y,
			     &rect.width, &rect.height)) {
	ret = PANGO_RBEARING(rect);
	return PyInt_FromLong(ret);
    }
    PyErr_Clear();
    PyErr_SetString(PyExc_ValueError, "rect must be a 4-tuple of integers");
    return NULL;
}
#line 4042 "pango.c"


PyMethodDef pypango_functions[] = {
    { "pango_attr_type_register", (PyCFunction)_wrap_pango_attr_type_register, METH_VARARGS|METH_KEYWORDS },
    { "AttrLanguage", (PyCFunction)_wrap_pango_attr_language_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrFamily", (PyCFunction)_wrap_pango_attr_family_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrForeground", (PyCFunction)_wrap_pango_attr_foreground_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrBackground", (PyCFunction)_wrap_pango_attr_background_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrSize", (PyCFunction)_wrap_pango_attr_size_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrStyle", (PyCFunction)_wrap_pango_attr_style_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrWeight", (PyCFunction)_wrap_pango_attr_weight_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrVariant", (PyCFunction)_wrap_pango_attr_variant_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrStretch", (PyCFunction)_wrap_pango_attr_stretch_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrFontDesc", (PyCFunction)_wrap_pango_attr_font_desc_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrUnderline", (PyCFunction)_wrap_pango_attr_underline_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrStrikethrough", (PyCFunction)_wrap_pango_attr_strikethrough_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrRise", (PyCFunction)_wrap_pango_attr_rise_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrShape", (PyCFunction)_wrap_pango_attr_shape_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrScale", (PyCFunction)_wrap_pango_attr_scale_new, METH_VARARGS|METH_KEYWORDS },
    { "AttrFallback", (PyCFunction)_wrap_pango_attr_fallback_new, METH_VARARGS|METH_KEYWORDS },
    { "parse_markup", (PyCFunction)_wrap_pango_parse_markup, METH_VARARGS|METH_KEYWORDS },
    { "pango_language_from_string", (PyCFunction)_wrap_pango_language_from_string1, METH_VARARGS|METH_KEYWORDS },
    { "pango_language_matches", (PyCFunction)_wrap_pango_language_matches1, METH_VARARGS|METH_KEYWORDS },
    { "PIXELS", (PyCFunction)_wrap_PANGO_PIXELS, METH_VARARGS|METH_KEYWORDS },
    { "ASCENT", (PyCFunction)_wrap_PANGO_ASCENT, METH_VARARGS|METH_KEYWORDS },
    { "DESCENT", (PyCFunction)_wrap_PANGO_DESCENT, METH_VARARGS|METH_KEYWORDS },
    { "LBEARING", (PyCFunction)_wrap_PANGO_LBEARING, METH_VARARGS|METH_KEYWORDS },
    { "RBEARING", (PyCFunction)_wrap_PANGO_RBEARING, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};


/* ----------- enums and flags ----------- */

void
pypango_add_constants(PyObject *module, const gchar *strip_prefix)
{
  pyg_enum_add(module, "AttrType", strip_prefix, PANGO_TYPE_ATTR_TYPE);
  pyg_enum_add(module, "Underline", strip_prefix, PANGO_TYPE_UNDERLINE);
  pyg_enum_add(module, "CoverageLevel", strip_prefix, PANGO_TYPE_COVERAGE_LEVEL);
  pyg_enum_add(module, "Style", strip_prefix, PANGO_TYPE_STYLE);
  pyg_enum_add(module, "Variant", strip_prefix, PANGO_TYPE_VARIANT);
  pyg_enum_add(module, "Weight", strip_prefix, PANGO_TYPE_WEIGHT);
  pyg_enum_add(module, "Stretch", strip_prefix, PANGO_TYPE_STRETCH);
  pyg_flags_add(module, "FontMask", strip_prefix, PANGO_TYPE_FONT_MASK);
  pyg_enum_add(module, "Alignment", strip_prefix, PANGO_TYPE_ALIGNMENT);
  pyg_enum_add(module, "WrapMode", strip_prefix, PANGO_TYPE_WRAP_MODE);
  pyg_enum_add(module, "TabAlign", strip_prefix, PANGO_TYPE_TAB_ALIGN);
  pyg_enum_add(module, "Direction", strip_prefix, PANGO_TYPE_DIRECTION);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pypango_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
        if (_PyGObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name GObject from gobject");
            return;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gobject");
        return;
    }


#line 468 "pango.override"
    PyPangoAttribute_Type.tp_alloc = PyType_GenericAlloc;
    PyPangoAttribute_Type.tp_new = PyType_GenericNew;
    if (PyType_Ready(&PyPangoAttribute_Type) < 0)
        return;

    PyPangoAttrIterator_Type.tp_alloc = PyType_GenericAlloc;
    PyPangoAttrIterator_Type.tp_new = PyType_GenericNew;
    if (PyType_Ready(&PyPangoAttrIterator_Type) < 0)
        return;

#line 4130 "pango.c"
    pyg_register_boxed(d, "AttrList", PANGO_TYPE_ATTR_LIST, &PyPangoAttrList_Type);
    pyg_register_boxed(d, "Color", PANGO_TYPE_COLOR, &PyPangoColor_Type);
    pyg_register_boxed(d, "FontDescription", PANGO_TYPE_FONT_DESCRIPTION, &PyPangoFontDescription_Type);
    pyg_register_boxed(d, "FontMetrics", PANGO_TYPE_FONT_METRICS, &PyPangoFontMetrics_Type);
    pyg_register_boxed(d, "GlyphString", PANGO_TYPE_GLYPH_STRING, &PyPangoGlyphString_Type);
    pyg_register_boxed(d, "Language", PANGO_TYPE_LANGUAGE, &PyPangoLanguage_Type);
    pyg_register_boxed(d, "TabArray", PANGO_TYPE_TAB_ARRAY, &PyPangoTabArray_Type);
    pygobject_register_class(d, "PangoContext", PANGO_TYPE_CONTEXT, &PyPangoContext_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "PangoFont", PANGO_TYPE_FONT, &PyPangoFont_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "PangoFontFace", PANGO_TYPE_FONT_FACE, &PyPangoFontFace_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "PangoFontFamily", PANGO_TYPE_FONT_FAMILY, &PyPangoFontFamily_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "PangoFontMap", PANGO_TYPE_FONT_MAP, &PyPangoFontMap_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "PangoFontset", PANGO_TYPE_FONTSET, &PyPangoFontset_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "PangoFontsetSimple", PANGO_TYPE_FONTSET_SIMPLE, &PyPangoFontsetSimple_Type, Py_BuildValue("(O)", &PyPangoFontset_Type));
    pygobject_register_class(d, "PangoLayout", PANGO_TYPE_LAYOUT, &PyPangoLayout_Type, Py_BuildValue("(O)", &PyGObject_Type));
}
